Package: leapR
Title: Layered enrichment analysis of pathways R
Version: 1.0.0
Authors@R: c(
    person("Sara", "Gosline", email = "sara.gosline@pnnl.gov", role = c('aut',"cre"), comment = c(ORCID = "0000-0002-6534-4774")),
    person("Jason", "McDermott", email = "jason.mcdermott@pnnl.gov", role = "aut"),
    person("Jeremy",'Jacobson', email = 'jeremy.jacobson@pnnl.gov', role = 'aut'),
    person("Vincent","Danna",email="vincent.danna@pnnl.gov",role='ctb'),
    person("National Institutes of Health", , role = 'fnd'))
Description: leapR is a package that identifies pathways that are enriched across diverse 'omics experiments. It leverages any tabular expression data (proteomics, transcriptomics) using the `SummarizedExperiment` object. It works with any pathway in the .gct file format. 
Depends: R (>= 4.5.0)
Encoding: UTF-8
LazyData: false
RoxygenNote: 7.3.3
biocViews: GeneSetEnrichment, Proteomics, Pathways, GeneExpression,
        Transcriptomics
Imports: stats, gplots, readr, tibble, gplots, methods, ggplot2, dplyr,
        stringr, tidyr, SummarizedExperiment, BiocStyle
Suggests: knitr, rmarkdown, testthat (>= 3.0.0)
VignetteBuilder: knitr
License: MIT + file LICENSE
Config/testthat/edition: 3
git_url: https://git.bioconductor.org/packages/leapR
git_branch: RELEASE_3_23
git_last_commit: 7469969
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 23:08:49 UTC; biocbuild
Author: Sara Gosline [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-6534-4774>),
  Jason McDermott [aut],
  Jeremy Jacobson [aut],
  Vincent Danna [ctb],
  National Institutes of Health [fnd]
Maintainer: Sara Gosline <sara.gosline@pnnl.gov>

# leapR

Layered Enrichment Analysis of Pathways in R (leapR) a tool that carries out statistical enrichment analysis on single- or multi-omics data.

## Install
leapR is available through Bioconductor repository here

```
if (!require("BiocManager", quietly = TRUE))
    install.packages("BiocManager")
BiocManager::install(version = "3.21")
BiocManager::install('BiocStyle')
BiocManager::install('leapR')
```

Once you have successfully installed the package you can load the vignette to read examples using the `vignette('leapR')` command.

## Basic Usage

The primary function of the `leapR` package is the `leapR` function itself. This function serves a wrapper to run different styles of enrichment functions on the data. The package contains other functions to support pathway information and multi-omics datasets.

### Enrichment calls

Here is a list of enrichment arguments that can be called with the `leapR` command.

| Argument                                        | Description |   
| ---                                             | ----        |   
| `enrichment_in_sets`                           | Calculates enrichment in pathway membership in a list (e.g. highly differential proteins) relative to background using Fisher's exact test. |   
| `enrichment_in_order`                         | Calculates enrichment of pathways based on a ranked list using the Kolmogorov-Smirnov test |   
| `enrichment_comparison`                         | Compares the distribution of abundances between two sets of conditions for each pathway using a t test  |
| `enrichment_in_pathways`                        | Compares the distribution of abundances in a pathway with the background distribution of abundances using a t test |   
|`correlation_enrichment`              | Calculates the enrichment of a pathway based on correlation between pathway members across conditions versus correlation between members not in the pathway             |   
| `enrichment_in_relationships`| Calculates the enrichment of a pathway in specified interactions relative to non-pathway members |

### Data examples
We included examples of including proteomics data and transcriptomics data from 169 high-grade serous ovarian cancer (HGSOC) tumors previously studied and lists of the short- and long- surviving patients from that cohort.

### Gene pathway examples
We included two different gene pathways. An NCI pathway database (Pathway Information Database; PID) of signaling pathways and the MSIGDB set of gene collections from various sources.

## Download files from msigdb
The extdata directory contains the Hallmarks of Cancer dataset from MSIGDB. To 
obtain this list, navigate to the [MSIGDB page](https://www.gsea-msigdb.org/gsea/msigdb/collections.jsp) and click on 
the 'Gene symbols' link under the 'Download GMT files' text to the right of the
"H: hallmark gene sets" section of the table. Login is required, but free. 

## ----knitr, include = FALSE---------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  cache = FALSE
)

## ----setup, eval = FALSE------------------------------------------------------
# # install from bioconductor
# if (!require(BiocManager)) {
#   install.packages('BiocManager')
#   BiocManager::install('leapR')
# }
# 

## ----libraries, message=FALSE, warning = FALSE--------------------------------
# load the core libraries
library(leapR)
library(gplots)
library(rmarkdown)
# plotting helpers used in this vignette
library(ggplot2)
library(dplyr)
library(tibble)
library(stringr)

## ----pathdb-------------------------------------------------------------------
data(ncipid)

## ----omicsdata, message=FALSE, warning=FALSE, echo = FALSE--------------------
url <- "https://api.figshare.com/v2/file/download/56536217"
pdata <- download.file(url, method = "libcurl", destfile = "protData.rda")
#  as.matrix()
load("protData.rda")

p <- file.remove("protData.rda")

url <- "https://api.figshare.com/v2/file/download/56536214"
tdata <- download.file(url, method = "libcurl", destfile = "transData.rda")
load("transData.rda")
p <- file.remove("transData.rda")

url <- "https://api.figshare.com/v2/file/download/56536211"
phdata <- download.file(url, method = "libcurl", destfile = "phosData.rda")
load("phosData.rda")
p <- file.remove("phosData.rda")

## ----show_pset_example--------------------------------------------------------
# Inspect the `pset` SummarizedExperiment.
str(pset)
dim(SummarizedExperiment::assay(pset, "proteomics"))
head(rownames(pset))
head(colnames(pset))

## ----ptlists------------------------------------------------------------------
data(shortlist)
data(longlist)

## columns that we want to use for results

cols_to_display <- c("ingroup_n", "outgroup_n", "background_n", 
                     "pvalue", "BH_pvalue")

## ----abundance, echo=TRUE, warning=FALSE, message=FALSE-----------------------
# in this example we lump a bunch of patients together (the 'short survivors')
# and compare them to another group (the 'long survivors')

### using enrichment_wrapper function
protdata.enrichment.svl <- leapR::leapR(
  geneset = ncipid,
  enrichment_method = "enrichment_comparison",
  eset = pset,
  assay_name = "proteomics",
  primary_columns = shortlist,
  secondary_columns = longlist
)

or <- order(unlist(protdata.enrichment.svl[, "pvalue"]))
rmarkdown::paged_table(protdata.enrichment.svl[or, cols_to_display])
# another application is to compare just one patient against another
# (this would be the  equivalent of comparing one time point to another)

### using enrichment_wrapper function
protdata.enrichment.svl.ovo <- leapR::leapR(
  geneset = ncipid,
  enrichment_method = "enrichment_comparison",
  eset = pset,
  assay_name = "proteomics",
  primary_columns = shortlist[1],
  secondary_columns = longlist[1]
)
or <- order(unlist(protdata.enrichment.svl.ovo[, "pvalue"]))
rmarkdown::paged_table(protdata.enrichment.svl.ovo[or, cols_to_display])

## ----fishers, echo=TRUE, warning=FALSE, message=FALSE-------------------------
# for this example we will construct a list of genes from the expression data
#     to emulate what you might be inputting
genelist <- rownames(pset)[which(SummarizedExperiment::assay(pset, 
                                                    "proteomics")[, 1] > 0.5)]

protdata.enrichment.sets.test <- leapR::leapR(
  geneset = ncipid,
  enrichment_method = "enrichment_in_sets",
  eset = pset,
  assay_name = "proteomics",
  targets = genelist
)
or <- order(protdata.enrichment.sets.test[, "pvalue"])
rmarkdown::paged_table(protdata.enrichment.sets.test[or, cols_to_display])



# in this example we construct some modules from the hierarchical clustering
#   of the   data
protdata_naf <- SummarizedExperiment::assay(pset, "proteomics")

# hierarchical clustering is not too happy with lots of missing values
#    so we'll do a zero fill on this to get the modules
protdata_naf[which(is.na(protdata_naf))] <- 0

# construct the hierarchical clustering using the 'wardD' method, which
#    seems to give more even sized modules
protdata_hc <- hclust(dist(protdata_naf), method = "ward.D2")

# arbitrarily we'll chop the clusters into 5 modules
modules <- cutree(protdata_hc, k = 5)

## sara: created list
clusters <- lapply(unique(modules), function(x) names(which(modules == x)))

# modules is a named list of values where each value is a module
#         number and the name is the gene name

# To do enrichment for one module (module 1 in this case) do this
protdata.enrichment.sets.module_1 <- leapR::leapR(
  geneset = ncipid,
  enrichment_method = "enrichment_in_sets",
  eset = pset,
  assay_name = "proteomics",
  targets = names(modules[which(modules == 1)])
)

# To do enrichment on all modules and return the list of enrichment results
protdata.enrichment.sets.modules <- do.call(rbind, 
                                            leapR::cluster_enrichment(
                                                eset = pset,
                                                assay_name= 'proteomics',
                                                geneset = ncipid,
                                                clusters = clusters, 
                                                sigfilter = 0.25))
## nothing is enriched
rmarkdown::paged_table(protdata.enrichment.sets.modules[, cols_to_display])

## ----fishers_plot, echo=TRUE, warning=FALSE, message=FALSE--------------------
# Plot the top enriched gene sets from Fisher's exact test
# Stars indicate significance (None seen here)
plot_leapr_bar(
  protdata.enrichment.sets.test,
  title = "Fisher's Exact Test: Top Enriched Pathways",
  top_n = 10,
  star_thresholds = c(0.05, 0.01, 0.001),
  wrap = 40
)

## ----ks, echo=TRUE, warning = FALSE, message=FALSE----------------------------
# This is how you calculate enrichment in a ranked list 
# (for example from topology)
### using enrichment_wrapper function
protdata.enrichment.order <- leapR::leapR(
  geneset = ncipid, "enrichment_in_order",
  eset = pset,
  method = 'ks',
  assay_name = "proteomics",
  primary_columns = shortlist[1]
)


or <- order(protdata.enrichment.order[, "pvalue"])
rmarkdown::paged_table(protdata.enrichment.order[or, cols_to_display])

## ----ks_plot, echo=TRUE, warning = FALSE, message=FALSE-----------------------
# Plot the ranked enrichment results
plot_leapr_bar(
  protdata.enrichment.order,
  title = "Kolmogorov-Smirnov Test: Ranked Enrichment",
  top_n = 12,
  fill_sig = "#2166AC",
  fill_ns = "#B2DFDB",
  wrap = 38
)

## ----zt, echo=TRUE, warning = FALSE, message=FALSE----------------------------
# This is how you calculate enrichment in a ranked list 
# (for example from topology)
### using enrichment_wrapper function
protdata.enrichment.order <- leapR::leapR(
  geneset = ncipid, "enrichment_in_order",
  eset = pset,
  method = 'ztest',
  assay_name = "proteomics",
  primary_columns = shortlist[1]
)


or <- order(protdata.enrichment.order[, "pvalue"])
rmarkdown::paged_table(protdata.enrichment.order[or, cols_to_display])

plot_leapr_bar(
  protdata.enrichment.order,
  title = "Z Test: Ranked Enrichment",
  top_n = 12,
  fill_sig = "#2166AC",
  fill_ns = "#B2DFDB",
  wrap = 38
)

## ----correlation, echo=TRUE, warning=FALSE, message=FALSE---------------------
### using enrichment_wrapper function
protdata.enrichment.correlation <- leapR::leapR(
  geneset = ncipid,
  enrichment_method = "correlation_enrichment",
  assay_name = "proteomics",
  eset = pset
)

or <- order(protdata.enrichment.correlation[, "pvalue"])
rmarkdown::paged_table(head(protdata.enrichment.correlation[or, 
                                                      cols_to_display]))

protdata.enrichment.correlation.short <- leapR::leapR(
  geneset = ncipid,
  enrichment_method = "correlation_enrichment",
  assay_name = "proteomics",
  eset = pset[, shortlist]
)
or <- order(protdata.enrichment.correlation.short[, "pvalue"])
rmarkdown::paged_table(head(protdata.enrichment.correlation.short[or, 
                                                        cols_to_display]))

protdata.enrichment.correlation.long <- leapR::leapR(
  geneset = ncipid,
  enrichment_method = "correlation_enrichment",
  assay_name = "proteomics",
  eset = pset[, longlist]
)
or <- order(protdata.enrichment.correlation.long[, "pvalue"])
rmarkdown::paged_table(head(protdata.enrichment.correlation.long[or, 
                                                            cols_to_display]))

## ----corr_plot, echo=TRUE, warning=FALSE, message=FALSE-----------------------
# Compare correlation patterns across conditions
plot_leapr_bar(
  protdata.enrichment.correlation.short,
  title = "Correlation Enrichment: Short Survivors",
  top_n = 10,
  fill_sig = "#1B9E77",
  fill_ns = "#D8F0E8",
  wrap = 36
)

## ----phosphoproteomics, echo=TRUE, warning=FALSE, message=FALSE---------------
data("kinasesubstrates")

# for an individual tumor calculate the Kinase-Substrate 
# Enrichment (similar to KSEA)
#     This uses the site-specific phosphorylation data to determine 
# which kinases
#     might be active by assessing the enrichment of the 
# phosphorylation of their known substrates

phosphodata.ksea.order <- leapR::leapR(
  geneset = kinasesubstrates,
  enrichment_method = "enrichment_in_order",
  assay_name = "phosphoproteomics",
  eset = phset,
  method = 'ztest', 
  primary_columns = "TCGA-13-1484")

or <- order(phosphodata.ksea.order[, "pvalue"])
rmarkdown::paged_table(phosphodata.ksea.order[or, cols_to_display])


# now do the same thing but use a threshold
phosphodata.sets.order <- leapR::leapR(
  geneset = kinasesubstrates,
  enrichment_method = "enrichment_in_sets",
  eset = phset,
  assay_name = "phosphoproteomics",
  threshold = 0.5,
  primary_columns = "TCGA-13-1484"
)
or <- order(phosphodata.sets.order[, "pvalue"])
rmarkdown::paged_table(phosphodata.sets.order[or, cols_to_display])

## ----phos_plot, echo=TRUE, warning=FALSE, message=FALSE-----------------------
plot <- plot_leapr_bar(
  phosphodata.sets.order,
  title            = "Kinase Substrate Enrichment (Phosphoproteomics)",
  top_n            = 15,
  star_thresholds  = c(0.05, 0.01, 1e-3),
  wrap             = 36,
  fill_sig         = "#0F766E",  # dark teal for significant
  fill_ns          = "#99F6E4",  # light teal for non-significant
  outline          = "grey30",
  axis_text_y_size = 7,
  axis_text_x_size = 8
)

plot

# You can also modify the plot further using standard ggplot2 arguments
plot + ggplot2::labs(
  y = expression(-log[10]("adjusted p-value")),
  caption = "* p<0.05, ** p<0.01, *** p<0.001"
)

## ----session------------------------------------------------------------------
sessionInfo()

#' correlation_enrichment
#'
#' # calculate enrichment in correlation between pathway members
#' # access through leapr wrapper
#' @importFrom stats sd
#' @importFrom stats p.adjust
#' @importFrom SummarizedExperiment SummarizedExperiment
#' @importFrom SummarizedExperiment assay
#' @importFrom SummarizedExperiment rowData
#' @param geneset Geneset list
#' @param eset a SummarizedExperiment object
#' @param assay_name name of assay
#' @param mapping_column Column to use to map identifiers, if not rownames
#' @return list of enrichment statistic table and correlation matrix

correlation_enrichment <- function(geneset, eset,
                                   assay_name,
                                   mapping_column = NA) {

  stopifnot(is(geneset,'geneset_data'),
            is(eset,'SummarizedExperiment'))

  ## which genes are in geneset
  allgenes <- unique(unlist(as.list(geneset$matrix)))

  # fixme: add support for an id column
  ids <- rownames(eset)
  cols <- seq_len(ncol(eset))
  if (!is.na(mapping_column)) {
    map <- SummarizedExperiment::rowData(eset)[, mapping_column, drop = TRUE]
  } else {
    map <- rownames(eset)
  }
  names(map) <- rownames(eset)
  allgenes_present <- names(map)[which(map %in% allgenes)]

  # NOTE: assumes that the mapping column is 1 and everything else
  #       is valid data- which may not be the case
  cm <- t(SummarizedExperiment::assay(eset, assay_name)[allgenes_present,
                                                        cols,
                                                        drop = FALSE])
  allgenes_cor <- cor(cm, use = "p")

  return(list(
    enrichment = enrichment_in_relationships(geneset,
                                             allgenes_cor, idmap = map),
    corrmat = allgenes_cor
  ))
}

#' @title Plot leapR pathway bars (single panel)
#' @description
#' This plotting helper expects leapR generated results to plot.
#' It will use BH_pvalue if present, otherwise pvalue.
#'
# REQUIRED ARGUMENTS
#' @param res_df A leapR df containing BH_pvalue (or pvalue) and a pathway/term label column.
#' @param title Plot title.
# OPTIONAL ARGUMENTS 
#' @param top_n Number of top pathways/genes to display.
#' @param star_thresholds list of numeric significance thresholds for star annotations.
#' @param wrap Wrap width for pathway labels (helps formatting).
#' @param max_stars Maximum number of stars to draw per bar (default 5).
#' @param fill_sig Fill color for significant bars
#' @param fill_ns Fill color for non-significant bars.
#' @param outline Bar border color.
#' @param axis_text_y_size Font size for y-axis (category) labels.
#' @param axis_text_x_size  Font size for x-axis (numeric) labels.
#'
#' @return A \pkg{ggplot2} object (or \code{NULL} if nothing to plot).
#' @export
plot_leapr_bar <- function(res_df,
                           title = NULL,
                           top_n = 15,
                           star_thresholds = c(0.05, 0.01, 0.001),
                           wrap = 42,
                           max_stars = 5L,
                           # colors
                           fill_sig = "#2C7BB6",   # darker for significant
                           fill_ns  = "#BFD7FF",   # lighter for non-significant
                           outline  = NA,
                           # text sizes
                           axis_text_y_size = 8,
                           axis_text_x_size = 9) {
  df <- .prep_bar_df(
    res_df           = res_df,
    top_n            = top_n,
    star_thresholds  = star_thresholds,
    wrap             = wrap,
    max_stars        = max_stars
  )
  if (is.null(df)) return(NULL)

  df_sig <- df[df$signif %in% TRUE, , drop = FALSE]

  ggplot2::ggplot(df, ggplot2::aes(x = stats::reorder(feature, score), y = score)) +
    ggplot2::geom_col(fill = fill_ns, width = 0.85, color = outline) +
    ggplot2::geom_col(data = df_sig, fill = fill_sig, width = 0.85, color = outline) +
    ggplot2::geom_text(ggplot2::aes(y = score + 0.12, label = stars),
                       size = 3, hjust = 0) +
    ggplot2::coord_flip(clip = "off") +
    ggplot2::scale_y_continuous(expand = ggplot2::expansion(mult = c(0, 0.12))) +
    ggplot2::theme_minimal(base_size = 11) +
    ggplot2::theme(
      panel.grid.major.x = ggplot2::element_blank(),
      axis.text.y        = ggplot2::element_text(size = axis_text_y_size),
      axis.text.x        = ggplot2::element_text(size = axis_text_x_size),
      plot.margin        = ggplot2::margin(5.5, 30, 5.5, 5.5)
    ) +
    ggplot2::labs(title = title, x = NULL,
                  y = expression(-log[10]("BH-adjusted p")~"(FDR)"))
}

# =========================
# Internal helpers (not exported)
# =========================

#' @keywords internal
#' @noRd
.pick_pcol <- function(df) {
  n <- colnames(df)
  if ("BH_pvalue"       %in% n) return(list(col = "BH_pvalue"))
  if ("pvalue" %in% n) return(list(col = "pvalue"))
  NULL
}

#' @keywords internal
#' @noRd
.stars_from_p <- function(p, cutoffs, max_stars = 5L) {
  if (is.na(p)) return("")
  n <- sum(p < cutoffs)
  n <- max(0L, min(as.integer(n), as.integer(max_stars)))
  if (n == 0L) "" else paste(rep("*", n), collapse = "")
}

#' @keywords internal
#' @noRd
.prep_bar_df <- function(res_df,
                         top_n = 15,
                         star_thresholds = c(0.05, 0.01, 0.001),
                         wrap = 42,
                         max_stars = 5L) {
  if (is.null(res_df)) return(NULL)
  df <- as.data.frame(res_df)
  if (!nrow(df)) return(NULL)

  term_col <- intersect(
    c("feature","term","Term","pathway","Pathway","set","Set","geneset","gene_set","Category"),
    colnames(df)
  )
  if (length(term_col)) {
    df$feature <- as.character(df[[term_col[1]]])
  } else if (!("feature" %in% names(df))) {
    df <- tibble::rownames_to_column(df, "feature")
  }

  picked <- .pick_pcol(df)
  if (is.null(picked)) {
    message("No BH-adjusted p-value column found (expected BH_pvalue or pvalue from leapR).")
    return(NULL)
  }

  adjp <- suppressWarnings(as.numeric(df[[picked$col]]))
  star_thresholds <- sort(unique(as.numeric(star_thresholds)))
  star_thresholds <- star_thresholds[is.finite(star_thresholds) & star_thresholds > 0]
  if (!length(star_thresholds)) star_thresholds <- c(0.05, 0.01, 0.001)

  out <- df |>
    dplyr::mutate(
      adj_p   = adjp,
      score   = -log10(pmax(adj_p, 1e-300)),
      stars   = vapply(adjp, .stars_from_p, character(1),
                       cutoffs = star_thresholds, max_stars = max_stars),
      signif  = !is.na(adj_p) & is.finite(adj_p) & (adj_p < max(star_thresholds)),
      feature = stringr::str_wrap(as.character(feature), width = wrap)
    ) |>
    dplyr::filter(is.finite(adj_p)) |>
    dplyr::arrange(adj_p, dplyr::desc(score)) |>
    dplyr::slice_head(n = top_n)

  if (!nrow(out)) return(NULL)
  out
}

# Example data
set.seed(1)
n <- 20
df <- data.frame(
feature    = paste0("Path_", seq_len(n)),
BH_pvalue  = runif(n, min = 1e-4, max = 0.2),
stringsAsFactors = FALSE
)

# Plot basic
p <- plot_leapr_bar(df, title = "Test", top_n = 10)
expect_s3_class(p, "ggplot")

# Check that its a ggplot object
# Check that the base layer has exactly 10( top_n) rows
gb <- ggplot2::ggplot_build(p)
expect_gte(length(gb$data), 2)
base_n <- nrow(gb$data[[1]])
expect_equal(base_n, 10)

#' enrichment_in_relationships
#'
#' enrichment_in_relationships function description is a general way to
#' determine if a pathway
#' is enriched in relationships (interactions, correlation) between its members
#' # access through leapr wrapper
#'
#' @param geneset List of pathways in gmt format
#' @param relationships table of relationship information, e.g. correlation
#' @param idmap list of identifiers to use for mapping, the names of the items
#' should agree with names of features in matrix
#' @param silence_try_errors boolean to silence errors
#' @return table of enrichment statistics
#' @importFrom stats sd
#' @importFrom stats p.adjust
#'
enrichment_in_relationships <- function(geneset,
                                        relationships,
                                        idmap = NA,
                                        silence_try_errors = TRUE) {
  # for each category in geneset calculates enrichment of within-group
  #     relationships relative to between-group relationships, where
  #     'relationships' are in the form of a square matrix (NxN) of
  #     continuous similarity metrics
  #     Currently uses a two-tailed t-test to assess this difference
  stopifnot(is(geneset,'geneset_data'))

  results2 <- vapply(seq_len(length(geneset$names)), function(i){
    thisname <- geneset$names[i]
    thissize <- geneset$size[i]
    thisdesc <- geneset$desc[i]
    grouplist <- geneset$matrix[i, seq_len(thissize)]

    if (!all(is.na(idmap))) {
      grouplist <- names(idmap)[which(idmap %in% grouplist)]
    }

    ingroup_ids <- grouplist[which(grouplist %in% rownames(relationships))]
    outgroup_ids <- rownames(relationships)[which(!rownames(relationships) %in%
                                                    grouplist)]

    # original way to do this is to take all relationships
    ingroup <- relationships[ingroup_ids, ingroup_ids, drop =FALSE]
    ingroup <- ingroup[upper.tri(relationships[ingroup_ids, ingroup_ids])]

    # pathway members versus all other components
    outgroup <- relationships[ingroup_ids, outgroup_ids]
    # non-pathway members versus non-pathway members
    outgroup_2 <- relationships[outgroup_ids, outgroup_ids, drop =FALSE]
    outgroup_2 <- outgroup_2[upper.tri(relationships[outgroup_ids,
                                                       outgroup_ids])]

    in_mean <- mean(unlist(ingroup), na.rm = TRUE)
    out_mean <- mean(unlist(outgroup), na.rm = TRUE)

    out_mean_2 <- mean(unlist(outgroup_2), na.rm = TRUE)

    pvalue <- NA
    pvalue_2 <- NA
    if (length(ingroup) > 1) {
      pvalue <- try(t.test(ingroup, outgroup)$p.value,
                    silent = silence_try_errors)
      if (is(pvalue, "try-error")) pvalue <- NA
      pvalue_2 <- try(t.test(ingroup, outgroup_2)$p.value,
                      silent = silence_try_errors)
      if (is(pvalue_2, "try-error")) pvalue_2 <- NA
      if (is.na(pvalue)) pvalue <- pvalue_2
    }

    delta <- in_mean - out_mean

    res <- c(ingroup_n = length(ingroup),
             ingroupnames = paste(ingroup_ids, collapse = ','),
             ingroup_mean = in_mean,
             outgroup_n =  length(outgroup),
             outgroup_mean = out_mean, zscore = NA,
             oddratio = delta, pvalue = pvalue,
             BH_pvalue = NA, SignedBH_pvalue = NA,
             background_n = NA, background_mean = NA)
    return(res)

  }, c(ingroup_n = numeric(1), ingroupnames = "", ingroup_mean = numeric(1),
       outgroup_n = numeric(1), outgroup_mean = numeric(1), zscore = numeric(1),
       oddsratio = numeric(1), pvalue = numeric(1),
       BH_pvalue = numeric(1), SignedBH_pvalue = numeric(1),
       background_n = numeric(1), background_mean = numeric(1)))

  results <- t(results2)
  rownames(results) <- geneset$names

  return(results)
}

# This file is part of the standard setup for testthat.
# It is recommended that you do not modify it.
#
# Where should you do additional test configuration?
# Learn more about the roles of various files in:
# * https://r-pkgs.org/testing-design.html#sec-tests-files-overview
# * https://testthat.r-lib.org/articles/special-files.html

library(testthat)
library(leapR)
data(ncipid)
data(shortlist)
data(longlist)

##download file once for all tests
pdata <- download.file("https://api.figshare.com/v2/file/download/56536217", method = "libcurl", destfile = "protData.rda")
load("protData.rda")
p <- file.remove("protData.rda")

test_check("leapR")

#' read_gene_sets
#'
#' read_gene_sets is a function to import external pathway
#' database files in .gmt format
#' @importFrom readr  read_lines
#' @param gsfile is a gene set file, for example a .gmt file
#' (gene matrix transposed file format)
#' @param gene.labels defaults to NA
#' @param gs.size.threshold.min defaults to 5
#' @param gs.size.threshold.max defaults to 15000
#' @return gene set object
#' @export
#' @return geneset list
#' @examples
#' gfile <- system.file('extdata','h.all.v2024.1.Hs.symbols.gmt',
#'           package='leapR')
#' glist <- read_gene_sets(gfile)
#'

read_gene_sets <- function(gsfile, gene.labels=NA,
                           gs.size.threshold.min=5,
                           gs.size.threshold.max=15000) {
  # Read input gene set database

  temp <- readr::read_lines(gsfile)

  max.Ng <- length(temp)
  temp.size.G <- vapply(seq_len(max.Ng), function(i){
    length(unlist(strsplit(temp[[i]], "\t"))) - 2
  }, double(1))

  max.size.G <- max(temp.size.G)
  gs_stats <- vapply(seq_len(max.Ng),function(i){
    gene.set.size <- length(unlist(strsplit(temp[[i]], "\t"))) - 2
    gs.line <- noquote(unlist(strsplit(temp[[i]], "\t")))
    gene.set.name <- gs.line[1]
    gene.set.desc <- gs.line[2]
    gene.set.tags <- vapply(seq_len(gene.set.size),
                            function(j) gs.line[j + 2], "")
      # we just want to load it all (unless we want to filter here?)
    existing.set <- rep(TRUE, length(gene.set.tags))

    set.size <- length(existing.set[existing.set == TRUE])
    if ((set.size < gs.size.threshold.min) ||
        (set.size > gs.size.threshold.max)) {
      return(NULL)
    }

    return(list(gvals = c(gene.set.tags[existing.set],
                          rep(NA, max.size.G - temp.size.G[i])),
                gsnames = gene.set.name,
                gsdesc = gene.set.desc,
                gsize = set.size))
  }, list(gvals = list(),gsnames = "",gsdesc = "",gsize = numeric(1)))

  gs.names <- apply(gs_stats, 2,function(g) return(g$gsnames))
  gs.desc <- apply(gs_stats,2,function(g) return(g$gsdesc))
  sizes <- apply(gs_stats, 2, function(g) return(g$gsize))
  gs <- apply(gs_stats,2, function(g) return(g$gvals))
  result <- list(names = gs.names, desc = gs.desc,
                 sizes = sizes, matrix = gs)

  class(result) <- c("geneset_data", "list")
  return(result)
}

#' enrichment_in_abundance
#'
#' Enrichment in abundance calculates enrichment in pathways by the difference
#' in abundance of the pathway members.
#' @importFrom stats sd
#' @importFrom stats p.adjust
#' @importFrom SummarizedExperiment assay
#' @importFrom SummarizedExperiment rowData
#' @importFrom SummarizedExperiment SummarizedExperiment

#' @param geneset Gene set to calculate enrichment
#' @param eset Molecular abundance data in `SummarizedExperiment` format
#' @param assay_name Name of assay to compare
#' @param mapping_column Column to use to map identifiers
#' @param abundance_column  Columns to use to quantify abundance
#' @param fdr number of times to sample for FDR value
#' @param matchset Name of a set to use for enrichment
#' @param sample_comparison list of samples to use as comparison. if missing
#' background (eset) is used
#' @param min_p_threshold  Only include p-values lower than this
#' @param sample_n size of sample to use
#' @param silence_try_errors set to true to silence try errors
#' @return data frame of enrichment result

enrichment_in_abundance <- function(geneset,eset, assay_name,
            mapping_column = NULL, abundance_column = NULL, fdr = 0,
           matchset = NULL, sample_comparison = NULL,
           min_p_threshold = NULL, sample_n = NULL, silence_try_errors = TRUE) {

    #required input is the geneset, background and an abundance column
    stopifnot(is(geneset,'geneset_data'),
              is(eset,'SummarizedExperiment'),
              !is.null(abundance_column))

    if (!is.null(mapping_column)) {
      groupnames <- SummarizedExperiment::rowData(eset)[, mapping_column,
                                                        drop = TRUE]
    } else {
      groupnames <- rownames(eset)
    }

    if (!is.null(matchset)) {
      geneset <- geneset[which(geneset$names %in% matchset)]
    }
    results2 <- vapply(seq_len(length(geneset$names)), function(i){

      thisname <- geneset$names[i]
      thissize <- geneset$size[i]
      thisdesc <- geneset$desc[i]
      grouplist <- setdiff(geneset$matrix[i, seq_len(thissize),
                                          drop = FALSE],"")
      ingroupnames <- grouplist[which(grouplist %in% groupnames)]
      outgroupnames <- groupnames[which(!groupnames %in% grouplist)] |> unique()

      if (!is.null(sample_n)) {
        if (sample_n <= length(ingroupnames) ||
          sample_n <= length(outgroupnames)) {
          ingroupnames <- sample(ingroupnames, sample_n)
          outgroupnames <- sample(outgroupnames, sample_n)
        }
      }
      ingroup <- SummarizedExperiment::assay(eset, assay_name)[
        which(groupnames %in% ingroupnames),
        abundance_column[which(abundance_column %in% colnames(eset))]
      ]

      if (!is.null(sample_comparison)) {
        outgroup <- SummarizedExperiment::assay(eset, assay_name)[
          which(groupnames %in% ingroupnames),
          sample_comparison[which(sample_comparison %in% colnames(eset)),
                            drop = FALSE]
        ]
      } else {
        outgroup <- SummarizedExperiment::assay(eset, assay_name)
        outgroup <- outgroup[which(groupnames %in% outgroupnames),
                             abundance_column, drop = FALSE]
      }
      in_mean <- mean(unlist(ingroup), na.rm = TRUE)
      out_mean <- mean(unlist(outgroup), na.rm = TRUE)
      pvalue <- NA
      if (length(ingroup) > 1) {
        pvalue <- try(t.test(unlist(ingroup), unlist(outgroup))$p.value,
          silent =
            silence_try_errors
        )
        if (is(pvalue, "try-error")) {
          pvalue <- NA
        }
      }

      delta <- in_mean - out_mean
      if (fdr) {
        background <- c()
        abundances <- c(ingroup, outgroup)
        for (i in seq_len(fdr)) { #add this to unit tests when you can
          # randomly sample genes for fdr times
          ingroup <- sample(seq_len(length(abundances)), length(ingroup))
          outgroup <- which(!seq_len(length(abundances)) %in% ingroup)
          ingroup <- abundances[ingroup]
          outgroup <- abundances[outgroup]
          in_mean <- mean(ingroup, na.rm = TRUE)
          out_mean <- mean(outgroup, na.rm = TRUE)
          delta_r <- in_mean - out_mean
          background <- c(background, delta_r)
        }
        pvalue <- sum(abs(background) > abs(delta)) / length(background)
      }

      ingroupnames <- paste(ingroupnames, collapse = ", ")
      # question : do we want to calculate an oddsratio for this too?
      # answer: yes, but for now we'll use the mean of the ingroup compared
      # with the
      #        distribution of the background as a zscore
      zscore <- (out_mean - in_mean) / sd(unlist(outgroup), na.rm = TRUE)

      res <- c(ingroup_n = length(unlist(ingroup)),
               ingroupnames = ingroupnames, ingroup_mean = in_mean,
               outgroup_n = length(unlist(outgroup)),
               outgroup_mean = out_mean, zscore = zscore,
               oddsratio = delta, pvalue = pvalue,
               BH_pvalue = NA, SignedBH_pvalue = NA,
               background_n = NA, background_mean = NA)

      return(res)

    },c(ingroup_n = numeric(1), ingroupnames = "",
        ingroup_mean = numeric(1),
        outgroup_n = numeric(1), outgroup_mean = numeric(1),
        zscore = numeric(1),
        oddsratio = numeric(1), pvalue = numeric(1),
        BH_pvalue = numeric(1), SignedBH_pvalue = numeric(1),
        background_n = numeric(1), background_mean = numeric(1)))
    # update
    results <- t(results2)
    rownames(results) <- geneset$names
    results <- as.data.frame(results)

    if (!is.null(min_p_threshold)) {
      results <- results[results[,'pvalue'] < min_p_threshold, ]
      return(results)
    } else {
      return(results)
    }
  }

#' difference_enrichment_in_relationships
#'
#' difference_enrichment_in_relationships function description calculates
#' the difference in two matrices, designed to be symmetric, that each
#' represent a relationship between features. e.g. correlation
#' a t-test is assessed between the two sets of values for each gene in a gene
#' set
#'
#' @param geneset is a list of pathways
#' @param relationships1 is a matrix of pairwise relationships between genes
#' @param relationships2 is a second matrix of pairwise relationships between
#' genes
#'
#' @noRd

difference_enrichment_in_relationships <- function(geneset,relationships1,
                                                   relationships2, idmap = NA) {
  stopifnot(is(geneset,'geneset_data'))
  results2 <- vapply(seq_len(length(geneset$names)), function(i){
    thisname <- geneset$names[i]
    thissize <- geneset$size[i]
    thisdesc <- geneset$desc[i]
    grouplist <- geneset$matrix[i, seq_len(thissize)]
    if (!all(is.na(idmap))) {
      grouplist <- names(idmap)[which(idmap %in% grouplist)]
    }

    # do these separately since the matrices could be different
    ingroup1_ids <- grouplist[which(grouplist %in% rownames(relationships1))]
    ingroup2_ids <- grouplist[which(grouplist %in% rownames(relationships2))]

    ingroup1 <- relationships1[ingroup1_ids, ingroup1_ids, drop = FALSE]
    ingroup1 <- ingroup1[upper.tri(relationships1[ingroup1_ids,
                                                   ingroup1_ids])]
    ingroup2 <- relationships2[ingroup2_ids, ingroup2_ids, drop = FALSE]
    ingroup2 <- ingroup2[upper.tri(relationships2[ingroup2_ids,
                                                    ingroup2_ids])]
    in_mean1 <- mean(unlist(ingroup1), na.rm = TRUE)
    in_mean2 <- mean(unlist(ingroup2), na.rm = TRUE)
    pvalue <- NA
    if (length(ingroup1) > 1 && length(ingroup2) > 1) {
      pvalue <- try(t.test(ingroup1, ingroup2)$p.value, silent = TRUE)
      if (is(pvalue, "try-error")) pvalue <- NA
    }

    res <- c(ingroup_n = length(ingroup1), ingroupnames = "",
             ingroup_mean = in_mean1,
             outgroup_n = length(ingroup2), outgroup_mean = in_mean2,
             zscore = NA,
             oddsratio = in_mean1 - in_mean2, pvalue = pvalue,
             BH_pvalue = NA, SignedBH_pvalue = NA,
             background_n = NA, background_mean = NA)

    return(res)

  },c(ingroup_n = numeric(1), ingroupnames = "", ingroup_mean = numeric(1),
      outgroup_n = numeric(1), outgroup_mean = numeric(1), zscore = numeric(1),
      oddsratio = numeric(1), pvalue = numeric(1),
      BH_pvalue = numeric(1), SignedBH_pvalue = numeric(1),
      background_n = numeric(1), background_mean = numeric(1)))

  results <- t(results2)
  rownames(results) <- geneset$names
  results <- as.data.frame(results)
  return(results)
}

#' correlation_comparison_enrichment
#'
#' # internal function to calculate enrichment in differences in correlation
#' # between two groups
#' # access through the leapr wrapper
#'
#' @importFrom stats sd
#' @importFrom stats p.adjust
#' @param geneset pathway to use for enrichment
#' @param eset  SummarizedExperiment with abundance matrix
#' @param assay_name name of assay
#' @param set1 first set to use
#' @param set2 second set to use
#' @param mapping_column Column to use for id mapping within rowData
#' @return data frame with enrichment results
#'
correlation_comparison_enrichment <- function(geneset, eset, assay_name,
                                              set1, set2,
                                              mapping_column = NA) {
  stopifnot(is(geneset,'geneset_data'),
            is(eset,'SummarizedExperiment'),
            length(set1) > 0,
            length(set2) > 0)

  allgenes <- unique(unlist(as.list(geneset$matrix)))
  if (length(set1) == 1 || length(set2) == 1) {
    stop('Need at least two samples in each group to compare')}

  ids <- rownames(eset)
  names(ids) <- rownames(eset)
  cols <- seq_len(ncol(eset))
  map <- NA
  if (!is.na(mapping_column)) {
    ids <- SummarizedExperiment::rowData(eset)[, mapping_column, drop = TRUE]
    names(ids) <- rownames(eset)
  }
  allgenes_present <- names(ids[which(ids %in% intersect(allgenes, ids))])

  if (is.na(mapping_column)) {
    ids <- NA ## set this back so next command can use rownames
  }
  cols1 <- colnames(eset)[which(colnames(eset) %in% set1)]
  cols2 <- colnames(eset)[which(colnames(eset) %in% set2)]

  abcols1 <- SummarizedExperiment::assay(eset,
                                         assay_name)[allgenes_present,
                                                     cols1, drop = FALSE]
  abcols2 <- SummarizedExperiment::assay(eset,
                                         assay_name)[allgenes_present,
                                                     cols2, drop = FALSE]

  abcols1 <- abcols1[which(rowSums(!is.na(abcols1)) > 0), cols1, drop = FALSE]
  abcols2 <- abcols2[which(rowSums(!is.na(abcols2)) > 0), cols2, drop = FALSE]

  allgenes_cor1 <- cor(t(abcols1), use = "p")
  allgenes_cor2 <- cor(t(abcols2), use = "p")

  return(difference_enrichment_in_relationships(geneset,
                                                allgenes_cor1,
                                                allgenes_cor2,
                                                idmap = ids))
}

#' enrichment_in_groups
#'
#' Calculate the enrichment in pathways using Fisher's exact or
#' Kolmogorov-Smirnov test, using either the abundance column to identify
#' feature or the targets list. access through leapr wrapper
#' @importFrom SummarizedExperiment SummarizedExperiment
#' @importFrom SummarizedExperiment rowData
#' @importFrom SummarizedExperiment assay
#' @importFrom stats sd
#' @importFrom stats p.adjust
#'
#' @param geneset geneset to use for enrichment
#' @param targets targets to use for enrichment
#' @param background `SummarizedExperiment` describing background to use
#' @param assay_name is the name of the assay to use from the background
#' @param method method to use for statistical test, options are
#' 'fishers', 'ks', 'ztest', or 'chisq'. Remember that KS test assumes normality, so it would be good
#' to log your data before calling. NOTE: if you do not call `suppressWarnings` then
#' the KS test will warn you about ties.
#' @param minsize minimum size of set
#' @param log_transformed Set to TRUE if data are log transformed
#' @param mapping_column column name of mapping identifiers
#' @param abundance_column columns mapping abundance, either in the `assay`
#' matrix or `rowData`
#' @param randomize true/false whether to randomize
#' @param silence_try_errors true/false to silence errors
#' @return data frame with enrichment results
#'
enrichment_in_groups <- function(geneset,
                                 targets = c(),
                                 background = NULL,
                                 assay_name = NULL,
                                 method = "fishers",
                                 minsize = 5,
                                 mapping_column = NULL,
                                 log_transformed = FALSE,
                                 abundance_column = NULL,
                                 randomize = FALSE,
                                 silence_try_errors = TRUE) {

  #required input is the geneset, background and list of targets
  stopifnot(is(geneset,'geneset_data'),
            is(background,'SummarizedExperiment'))

  ##loop through every pathway for enrichment test
  results2 <- vapply(seq_len(length(geneset$names)), function(i){
    thisname <- geneset$names[i]
    thissize <- geneset$size[i]
    thisdesc <- geneset$desc[i]
    grouplist <- setdiff(geneset$matrix[i, seq_len(thissize)], c("null",""))
    if (randomize) {
      # choose a random set of genes as this grouplist
      # A disadvantage is that we resample for each functional group rather than
      #   running one set of analyses on a fully scrambled set of functions.
      grouplist <- sample(unlist(geneset$matrix), length(grouplist))
    }

    # grouplist and backlist
    # are both list of feature names of foreground/background
     if (!is.null(mapping_column)) {
        backlist <- SummarizedExperiment::rowData(background)[, mapping_column,
                                                                drop = TRUE] |>
        unique()
     }else{
      backlist <- rownames(background)
     }
    backlist <- unlist(backlist)
    in_back <- length(backlist)

    if (method == "fishers") {
      stopifnot(length(targets) > 0)
      enr <- enrichment_by_fishers(targets, backlist, grouplist)
      p <- enr$fisher$p.value
      f <- enr$foldx
      mat <- enr$mat
      names <- enr$in_path_names
      res <- c(ingroup_n = mat[1, 1], ingroupnames = names, ingroup_mean = NA,
               outgroup_n = mat[1, 2], outgroup_mean = NA, zscore = NA,
               oddsratio = f, pvalue = p,BH_pvalue = NA, SignedBH_pvalue = NA,
               background_n = mat[2,2], background_mean = mat[2,1])

    } else if (method %in% c('ks','ztest','chisq')) { ##try out one of our 
      #three continuous tests
       # in this case "background" must be the continuous variable
       #lets ensure that the data are normally distributed

      #these are the indices of the background
      group_ind <- which(backlist %in% grouplist)
      in_group_name <- paste(intersect(backlist, grouplist), collapse = ", ")

      if (any(abundance_column %in% colnames(background))) {
       #  in_group <- SummarizedExperiment::assay(background)[group_ind,
      #                                                       abundance_column,
      #                                                       drop = TRUE]
         backvals <- SummarizedExperiment::assay(background)[,
                                                             abundance_column,
                                       drop = TRUE]
      } else { ##we are working with rowData
       # in_group <- SummarizedExperiment::rowData(background)[group_ind,
      #                                                        abundance_column,
      #                                drop = TRUE]
        backvals <- SummarizedExperiment::rowData(background)[,
                                                              abundance_column,
                                      drop = TRUE]
      }

      ##make normal - this is new and might change results
     backvals <- (backvals - mean(backvals, na.rm=T))/sd(backvals,na.rm=T)
      
      in_group <- backvals[group_ind]
      ##remove NA vals from in group
      in_group <- in_group[!is.na(in_group)]
      in_group_mean <- mean(in_group)
      
      names(backvals) <- backlist#[-group_ind]
      in_back <- length(backvals)
      
      outgroup_mean = mean(backvals[-group_ind], na.rm = T)
      
      in_path <- length(in_group) #how many left after na.rm
      if ((in_path > minsize) & (any(!is.na(in_path))) &
         !all(is.na(in_group))) {
        if (method == 'ks') { 
              in_back <- length(backlist)
              enr <- NA
              enr <- tryCatch(
          {
            #suppressWarnings(
            ks.test(in_group, backvals[-group_ind], exact = FALSE)#)
          })
          if (length(enr) > 1) {
            p.value <- enr$p.value
          } else {
            p.value < -NA
          }
          # this expression of foldx might be subject to some weird pathological
          # conditions e.g. one sample has a background that is always negative,
          # another that's positive may pertain to zscore too (although not sure
          # it should) rank from largest to smallest
          if (is.null(mapping_column)) {
            in_rank <- rank(-backvals)[which(rownames(background) %in%
                    #  backvals[which(rownames(background) %in%                  
                                       grouplist)]
          } else {
            in_rank <- rank(-backvals)[which(names(backvals) %in% grouplist)]
          }
          # this will give not a fold enrichment - but a score that ranges
          # from 1 (most in top)
          #      to -1 (most in bottom).
          foldx <- 1 - ((mean(in_rank) / length(backvals)) / 0.5)
        } else if (method == 'ztest') {
        ##add z test here
            foldx <- sqrt(thissize) * in_group_mean #z test
            p.value <- 2 * pnorm(-abs(foldx)) #2 sided pvalue
        } else if (method == 'chisq') {
         #add chisq test here
          foldx <- vapply(in_group, function(x) (x - in_group_mean)^2,numeric(1))
          foldx <- (sum(foldx) - (thissize - 1))/(2*(thissize - 1))
          p.value <- 2 * pnorm(-abs(foldx)) # 2 sided pvalue
        } 
        zscore <- (in_group_mean - outgroup_mean)
        zscore <- zscore / sd(in_group)

       
      res <- c(ingroup_n = in_path, ingroupnames = in_group_name,
               ingroup_mean = in_group_mean,
               outgroup_n = in_back, outgroup_mean = outgroup_mean,
               zscore = zscore,
               oddsratio = foldx, pvalue = p.value,
               BH_pvalue = NA, SignedBH_pvalue = NA,
               background_n = NA, background_mean = NA)
      }  else{
        res <- c(ingroup_n = in_path, ingroupnames = in_group_name,
                 ingroup_mean = in_group_mean,
                 outgroup_n = in_back, outgroup_mean = outgroup_mean,
                 zscore = NA,
                 oddsratio = NA, pvalue = NA,
                 BH_pvalue = NA, SignedBH_pvalue = NA,
                 background_n = NA, background_mean = NA)
      } 
    } 
    else {
        res <- c(ingroup_n = in_path, ingroupnames = in_group_name,
                   ingroup_mean = NA,
                   outgroup_n = in_back, outgroup_mean = mean(backvals,
                                                              na.rm = TRUE),
                   zscore = NA,
                 oddsratio = NA, pvalue = NA,
                 BH_pvalue = NA, SignedBH_pvalue = NA,
                 background_n = NA, background_mean = NA)
      }
  
    
    return(res)
  
  }, c(ingroup_n = numeric(1), ingroupnames = "", ingroup_mean = numeric(1),
       outgroup_n = numeric(1), outgroup_mean = numeric(1),
       zscore = numeric(1),
       oddsratio = numeric(1), pvalue = numeric(1),
       BH_pvalue = numeric(1), SignedBH_pvalue = numeric(1),
       background_n = numeric(1), background_mean = numeric(1)))
  results <- t(results2)
  rownames(results) <- geneset$names
  results <- as.data.frame(results)

  return(results)
}

#' combine_omics
#' Combine two or more omics matrices into one multi-omics matrix with
#' 'tagged' ids.
#'
#' @importFrom SummarizedExperiment SummarizedExperiment
#' @importFrom SummarizedExperiment rowData
#' @importFrom SummarizedExperiment assay
#' @importFrom SummarizedExperiment assays
#' @param omics_list Is a list of \code{SummarizedExperiment} each with
#'  one assay
#' @param id_list List of identifiers to use, in the same order as the
#' omics_list elements. If an element
#' is `NA`, then rownames are used.
#' @return \code{SummarizedExperiment} with an additional assay called
#'  `combined`
#' @details This combines matrices of different omics types together and
#' adds prefix tags to the ids.
#'
#' @examples
#'         library(leapR)
#'         url <- 'https://api.figshare.com/v2/file/download/56536217'
#'
#'         pdata <- download.file(url,method='libcurl',destfile='protData.rda')
#'         load('protData.rda')
#'         p <- file.remove("protData.rda")
#'
#'         url <- "https://api.figshare.com/v2/file/download/56536214"
#'         tdata <- download.file(url,method='libcurl',destfile='transData.rda')
#'         load('transData.rda')
#'         p <- file.remove("transData.rda")
#'
#'         url <- 'https://api.figshare.com/v2/file/download/56536211'
#'         phdata<-download.file(url,method='libcurl',destfile = 'phosData.rda')
#'         #phosphodata<-read.csv("phdata",check.names=FALSE,row.names=1)
#'         load('phosData.rda')
#'         p <- file.remove('phosData.rda')# read in the example protein data
#'
#'
#'         # merge the three datasets by rows and add prefix tags for
#'         # different omics types
#'         multi_omics <- combine_omics(list(pset, tset, phset),
#'                     list(NA,NA,'hgnc_id'))
#'
#'
#' @export


combine_omics <- function(omics_list, id_list = rep(NA,length(omics_list))){

  # find the common subset of colnames
  common_conditions <- NA
  for (this in omics_list) { ##cannot seem to get rid of for loops
      if (all(is.na(common_conditions))) common_conditions <- colnames(this)
      that <- colnames(this)
      common_conditions <- common_conditions[which(common_conditions %in% that)]

  }

  stopifnot(length(common_conditions) >0)

  result <- NA
  allfeat <- NA
  for (i in seq_len(length(omics_list))) {
    ##cannot seem to get rid of for loops for this test
    this <- omics_list[[i]]
    id_column <- id_list[[i]]

    ##first lets pull some metadata out
    feat <-  names(SummarizedExperiment::assays(this))[1]
    tag <- paste0(substr(feat,0,3),'_')

    #now let's get the common conditions
    this <- this[,common_conditions, drop = FALSE]

    if (!is.na(id_column)) {
        # we need to add an id_column or use one that's here
          # add the idcolumn from the input phospho data
      ids <- SummarizedExperiment::rowData(this)[,id_column, drop = TRUE]
    }else {
      ids <- rownames(this)
    }

      idval <- data.frame(id = ids)

      # tag all the ids appropriately
      expr <- SummarizedExperiment::assay(this,feat)
      rownames(expr) <- vapply(rownames(expr), function(n)
        paste0(tag, n, sep = "_"), "")

      if (all(is.na(result))) result <- expr
      else result <- rbind(result, expr)

      if (all(is.na(allfeat))) allfeat <- idval
      else allfeat <- rbind(allfeat,idval)

  }

  allfeat <- data.frame(allfeat)
  rownames(allfeat) <- rownames(result)
  alist <-  as(list(combined = result),'SimpleList')
  res <- SummarizedExperiment::SummarizedExperiment(assays = alist,
                                                    rowData = allfeat)
  return(res)
}

#' calcTTest
#'
#' calculates a t-test for two distributions of data on a per-gene basis
#' append results to ExpressionSet with two extra columns: `pvalue` and
#' `difference` for each feature

#' @importFrom SummarizedExperiment assay
#' @importFrom SummarizedExperiment SummarizedExperiment
#' @importFrom SummarizedExperiment rowData
#' @param eset SummarizedExperiment
#' @param assay_name name of assay
#' @param group1 List of samples comprising group 1
#' @param group2 List of samples comprising group 2
#' @return An Expression set with two columns added to the featureData
#' slot: pvalue, and estimate
#' @export
#'
#' @examples
#'
#'         library(leapR)
#'         url <- "https://api.figshare.com/v2/file/download/56536214"
#'         tdata <- download.file(url,method='libcurl',destfile='transData.rda')
#'         load('transData.rda')
#'         p <- file.remove("transData.rda")
#'
#'         # read in the pathways
#'         data("ncipid")
#'
#'         # read in the patient groups
#'         data("shortlist")
#'         data("longlist")
#'         calcTTest(tset, 'transcriptomics', shortlist, longlist)


calcTTest <- function(eset, assay_name, group1, group2){
  stopifnot(is(eset,'SummarizedExperiment'),
            length(group1) > 0,
            length(group2) > 0)

  exprdata <- SummarizedExperiment::assay(eset, assay_name)

  res <- t(vapply(rownames(exprdata), function(r) {
    if (length(which(!is.na(exprdata[r,group1, drop = FALSE]))) > 2 &&
        length(which(!is.na(exprdata[r,group2, drop = FALSE]))) > 1) {
      res <- t.test(exprdata[r,group1, drop = FALSE],
                    exprdata[r,group2, drop = FALSE])

      return(c(pvalue = res$p.value,
               difference  = res$estimate[[1]] - res$estimate[[2]]))
    }
    else{
      return(c(pvalue = NA,difference = NA))
    }
  }, numeric(2)))

  f <- SummarizedExperiment::rowData(eset)
  f <- cbind(f, res)

  SummarizedExperiment::rowData(eset) <- f
  return(eset)
}

#' get_pathway_information
#'
#' get_pathway_information extracts information about a pathway from a
#' GeneSet object
#'
#' @param geneset is a GeneSet object for pathway annotation
#' @param path  is the name of the gene set pathway to be return
#' @param remove.tags boolean indicating whether to remove tags
#' @return list of pathway information
#' @examples
#'
#'      library(leapR)
#'
#'      # load example gene set
#'      data("ncipid")
#'
#'      tnfpathway = get_pathway_information(ncipid, "tnfpathway")
#'
#'
#' @export
#'

get_pathway_information <- function(geneset, path, remove.tags=FALSE) {
  i <- which(geneset$names == path)
  thissize <- geneset$size[i]
  thisdesc <- geneset$desc[i]

  # default is to look through all members for effects on the pathway
  grouplist <- geneset$matrix[i,seq_len(thissize)]
  grouplist <- unique(sort(grouplist[which(grouplist != "")]))

  if (remove.tags) {
    grouplist <- unique(vapply(grouplist, function(n)
      strsplit(n, "_")[[1]][2], ""))
  }
  thissize <- length(grouplist)

  return(list(name = path, size = thissize,
              description = thisdesc, geneset = grouplist))
}

#' NCI Gene lists
#'
#' A list of pathways and the genes that comprise these pathways
#' @format A list with 4 items
#' \describe{
#' \item{names}{The names of the signaling pathways}
#' \item{desc}{Short description of the pathways}
#' \item{sizes}{Number of genes in the signaling pathways}
#' \item{matrix}{Matrix containing the genes in the pathways}
#' }
#' @source NCIPID
#'
"ncipid"

#' KEGG, Reactome, BioCarta Pathways
#'
#' @format A list with 4 items
#' \describe{
#' \item{names}{The names of the pathways}
#' \item{desc}{Short description of the pathways}
#' \item{sizes}{Number of genes in the signaling pathways}
#' \item{matrix}{Matrix containing the genes in the pathways}
#' }
#' @source https://www.gsea-msigdb.org/gsea/msigdb_license_terms.jsp
#'
"krbpaths"

#' Kinase substrate lists
#'
#' @format A list with 4 items
#' \describe{
#' \item{names}{The names of the kinases}
#' \item{desc}{Short description of the kinase}
#' \item{sizes}{Length of the substrate list}
#' \item{matrix}{Substrate list for the kinase}
#' }
#' @source PhosphositePlus
#'
"kinasesubstrates"


#' A list of pathways and genes that comprise these pathways from msigdb
#' @format a list with 4 items
#'
#' Short list of patient samples
#'
"shortlist"
#' Long list of patient samples
#'
"longlist"

#' leapR
#'
#' leapR is a wrapper function that consolidates multiple enrichment methods.
#'
#' @param geneset is a list of four vectors, gene names, gene descriptions, gene
#' sizes and a matrix of genes. It represents .gmt format pathway files.
#' @param enrichment_method is a character string specifying the method of
#' enrichment to be performed, one of: "enrichment_comparison",
#' "enrichment_in_order", "enrichment_in_sets", "enrichment_in_pathway",
#' "correlation_enrichment".
#' @param eset is a `SummarizedExperiment` object containing expression data,
#' with features as rows and \emph{n} sample/conditions as columns.
#' @param assay_name is the assay to be analyzed within the `eset`.
#' Recommended to describe the data type (e.g. transcriptomics, proteomics)
#' so that it can be integrated in `combine_omics`
#' @return data frame with results
#' @importFrom SummarizedExperiment SummarizedExperiment
#' @importFrom SummarizedExperiment rowData
#' @importFrom SummarizedExperiment assay
#' @param ... further arguments
#'
#'
#' @details
#' Further arguments and enrichment method optional argument information: \cr
#' \tabular{ll}{
#' id_column \tab Is a character string, present in the \code{rowData} slot,
#' that is used to specify a column for identifiers to map to enrichment
#' libraries.
#' If missing, the rownames of the SummarizedExperiment assay will be used.
#' \cr
#' primary_columns \tab Is a character vector composed of column names from
#' \code{eset} (either in the `assay` or in the `rowData`),
#' that specifies a set of primary columns to calculate enrichment on.
#' The meaning of this varies according to the enrichment method used - see
#' the descriptions for each method below.
#' This is an optional argument used with 'enrichment_in_order',
#' 'enrichment_in_sets', and 'enrichment_comparison' methods. \cr
#' \cr
#' secondary_columns \tab Is a character vector of column names for comparison,
#' pulled from the `assay` of the SummarizedExperiment. This is an
#' optional argument used with 'enrichment_comparison' methods. \cr
#' \cr
#' threshold \tab Is a numeric value, an optional argument used with
#' 'enrichment_in sets' method which filters out abundance values or p-values
#' (depending on what `primary_columns` is used)
#' either above or below it. \cr
#' \cr
#' greaterthan \tab Is a logical value that defaults to TRUE, it's used with
#' 'enrichment_in_sets' method.
#' When set to TRUE, genes with `primary_columns` value above the
#' \code{threshold} argument are kept.
#' When set to FALSE genes with `primary_columns` value below the
#' \code{threshold} argument are kept.
#' This is an optional argument used with 'enrichment_in_sets' method. \cr
#' \cr
#' minsize \tab Is a numeric value, an optional argument used with
#' 'enrichment_in_sets' and 'enrichment_in_order". \cr
#' \cr
#' fdr \tab A numerical value which specifies how many times to randomly
#' sample genes to calculate an empirical false discovery rate, is an optional
#' argument used with 'enrichment_comparison' method. \cr
#' \cr
#' min_p_threshold \tab Is a numeric value, a lower p-value threshold and is an
#' optional argument used with 'enrichment_comparison' method. \cr
#' \cr
#' sample_n \tab Is a way to subsample the number of components considered for
#' each calculation randomly. This is an optional argument used with
#' 'enrichment_comparison' method. \cr
#' \cr
#' }
#'
#' \strong{Enrichment Methods:}
#' \cr
#' \cr
#' enrichment_comparison
#' \cr
#' Compares the distribution of abundances between two sets of
#' conditions for each pathway using a t test. For each pathway in
#' \code{geneset} uses a t test to compare the distribution of abundance
#' values/numbers in \code{eset} \code{primary_columns} with those in
#' \code{eset} \code{secondary_columns}. Lower p-values for pathways indicate
#' that the expression of the pathway is significantly different between the
#' set of conditions in primary_columns and the set of conditions in
#' secondary_columns.
#' Optionally, users can specify \code{fdr} which will calculate an empirical
#' p-value by randomizing abundances \code{fdr} number of times. If the
#' \code{min_p_threshold} is specified the method will only return pathways
#' with an adjusted p-value lower than the specified threshold. If
#' \code{sample_n} is specified the method will subsample the
#' pathway members to the specified number of components.
#' \cr \cr
#' enrichment_in_order
#' \cr
#' Calculates enrichment of pathways based on a ranked list using the
#' Kolmogorov-Smirnov test. For each pathway in \code{geneset} uses a
#' Kolmogorov-Smirnov test for rank order to test if the distribution of ranked
#' abundance values in the \code{eset} \code{primary_columns} is significant
#' relative to a random distribution. Note that currently
#' \code{primary_columns} only accepts a single column for this method.
#' \cr \cr
#' enrichment_in_sets
#' \cr
#' Calculates enrichment in pathway membership in a list (e.g. highly
#' differential proteins) relative to background using Fisher's exact test. For
#' each pathway in \code{geneset} uses a Fisher's exact test over- or under-
#' representation of a list of components specified. If \code{targets} are
#' specified this must be a vector of identifiers to serve as the target list
#' for comparison. If \code{eset} and \code{primary_columns} are specified then
#' \code{threshold} specifies a threshold value for determining the target list
#' of components to test. Specifying \code{greaterthan} to be False
#' will result in components with values lower than the specified
#' \code{threshold}. If \code{eset} is a data frame or matrix, the background
#' used for calculation will be taken as the rownames of \code{eset}
#' \cr \cr
#' enrichment_in_pathway
#' \cr
#' Compares the distribution of abundances in a pathway with the background
#' distribution of abundances using a t test. For each pathway in
#' \code{geneset} calculates the significance of the difference between the
#' abundances from pathway members versus abundance of non-pathway members in
#' the set of conditions specified by \code{primary_columns}. Optionally, users
#' can specify \code{fdr} which will calculate an empirical p-value by
#' randomizing abundances \code{fdr} number of times. If the
#' \code{min_p_threshold} is specified the method will only return pathways
#' with an adjusted p-value lower than the specified threshold. If
#' \code{sample_n} is specified the method will subsample the
#' pathway members to the specified number of components.
#' \cr \cr
#' correlation_enrichment
#' \cr
#' Calculates the enrichment of a pathway based on correlation between pathway
#' members across conditions versus correlation between members not in the
#' pathway. For each pathway in \code{geneset} calculates the pairwise
#' correlation between all pathway members and non-pathway members
#' across the specified \code{primary_columns} conditions in \code{eset}. Note
#' that for large matrices this can take a long time. A p-value is calculated
#' based on comparing the correlation within the members of a pathway with the
#' correlation values between members of the pathway and non-members of the
#' pathway.
#' \cr
#' @examples
#'         library(leapR)
#'
#'  # read in the example abundance data
#'  # read in the example transcriptomic data
#'  tdata <- download.file("https://api.figshare.com/v2/file/download/56536214",
#'       method='libcurl',destfile='transData.rda')
#'  load('transData.rda')
#'  p <- file.remove("transData.rda")
#'
#'  # read in the pathways
#'  data("ncipid")
#'
#'  # read in the patient groups
#'  data("shortlist")
#'  data("longlist")
#'
#'  # use enrichment_comparison to calculate enrichment in one set of
#'  # conditions (shortlist) and another (longlist)
#'  short_v_long = leapR(geneset=ncipid, assay_name='transcriptomics',
#'               enrichment_method='enrichment_comparison',
#'               eset=tset, primary_columns=shortlist,
#'                secondary_columns=longlist)
#'
#'  # use enrichment_in_sets to calculate the most enriched pathways
#'  # from the highest abundance proteins
#'  #     from one condition
#'  onept_sets = leapR(geneset=ncipid, assay_name='transcriptomics',
#'                enrichment_method='enrichment_in_sets',
#'                eset=tset, primary_columns="TCGA-13-1484", threshold=1.5)
#'
#'  # use enrichment_in_order to calculate the most enriched pathways from the
#'  # same condition
#'  # Note: that this uses the entire set of abundance values and their order -
#'  # whereas the previous example uses a hard threshold to get a short list of
#'  # most abundant proteins and calculates enrichment based on set overlap.
#'  # The results are likely to be similar - but with some notable differences.
#'  onept_order = leapR(geneset=ncipid, assay_name='transcriptomics',
#'                enrichment_method='enrichment_in_order',
#'                eset=tset, primary_columns="TCGA-13-1484")
#'
#'  # use enrichment_in_pathway to calculate the most enriched pathways in a
#'  # set of conditions based on abundance in the pathway members versus
#'  # abundance in non-pathway members
#'  short_pathways = leapR(geneset=ncipid, assay_name='transcriptomics',
#'                enrichment_method='enrichment_in_pathway',
#'                eset=tset, primary_columns=shortlist)
#'
#'  # use correlation_enrichment to calculate the most enriched pathways in
#'  # correlation across the shortlist conditions
#'  short_correlation_pathways = leapR(geneset=ncipid,
#'                 assay_name='transcriptomics',
#'                 enrichment_method='correlation_enrichment',
#'                 eset=tset, primary_columns=shortlist)
#'
#'
#' @export
#'

leapR <- function(geneset, enrichment_method, eset, assay_name, ...){

  #there are three required elements; an enrichment method, a geneset, and a
  #summarized experiment
  stopifnot(enrichment_method %in% c("correlation_enrichment",
                                     "correlation_comparison",
                                     "enrichment_in_order",
                                     "enrichment_comparison",
                                     "enrichment_in_pathway",
                                     "enrichment_in_sets"),
            is(geneset,'geneset_data'),
            is(eset,'SummarizedExperiment'))

  if (missing(assay_name)) {
    assay_name <- names(assay(eset))[1]
  }

  .enrichment_wrapper(geneset, enrichment_method, eset, assay_name, ...)
}

.enrichment_wrapper <- function(geneset,enrichment_method, eset, assay_name,
                                id_column=NULL, primary_columns=NULL,
                                secondary_columns=NULL, threshold=NULL,
                                minsize=5, mode=NULL, method = 'ks',
                                log_transformed = FALSE,
                                fdr=0, min_p_threshold=NULL, sample_n=NULL,
                               significance_threshold=NA,  targets=NULL,
                               greaterthan=TRUE){

  if (enrichment_method == "enrichment_in_order") {
    # eset will replace background - but we can do that at this level and
    # randomize might change - TBD
    stopifnot(!is.null(primary_columns), length(primary_columns) == 1)
    ##primary_columsn can be in either the abundance data or the featureData,
    all_names <- c(colnames(eset),
                     colnames(SummarizedExperiment::rowData(eset)))

    stopifnot(is.element(primary_columns, all_names))

    result <- enrichment_in_groups(geneset = geneset,
                                     background = eset,
                                     assay_name = assay_name,
                                     minsize = minsize,
                                     method = method,
                                     log_transformed = log_transformed,
                                     mapping_column = id_column,
                                     abundance_column = primary_columns)
  }

  else if (enrichment_method == "enrichment_in_sets") {
    # eset will replace background
    # primary_columns will replace abundance column
    # minsize will remain the same
    # id_column will replace mapping_column
    # randomize isn't implemented for this application
    stopifnot(!is.null(primary_columns) ||
                !is.null(threshold) || !is.null(targets))
    ##primary_columsn can be in either the abundance data or the featureData,
    all_names <- c(colnames(eset),
                   colnames(SummarizedExperiment::rowData(eset)))
    stopifnot(is.element(primary_columns, all_names))

    if (!is.null(primary_columns) && primary_columns %in% colnames(eset)) {
     targ_vec <- SummarizedExperiment::assay(eset,assay_name)[,primary_columns]
    } else {
     targ_vec <- SummarizedExperiment::rowData(eset)[,primary_columns]
    }
    if(!is.null(threshold)){
        if (greaterthan == FALSE ) {
            targ_ind <- which(targ_vec < threshold)
        }else{
            targ_ind <- which(targ_vec > threshold)
        }
    }

    if (!is.null(id_column)) {
      if (!is.element(id_column,
                      colnames(SummarizedExperiment::rowData(eset)))) {
          stop("'id_column' must be a column name of 'rowData(eset)'")}
    }

    if (is.null(targets)) {
      if (!is.null(id_column)) {
        targets <- unique(SummarizedExperiment::rowData(eset)[targ_ind,
                                                              id_column])
      }else{
        targets <- rownames(eset)[targ_ind]
      }
    }

    if (length(targets) == 0)
    {
        stop("please adjust 'threshold' argument, \
           there are no target genes captured by current threshold value")}

      result <- enrichment_in_groups(geneset = geneset, targets = targets,
                                     mapping_column = id_column,
                                     background = eset, method = "fishers",
                                     minsize = minsize)

  }

  else if (enrichment_method == "enrichment_in_pathway") {
      result <- enrichment_in_abundance(geneset = geneset, eset = eset,
                                        assay_name = assay_name,
                                        mapping_column = id_column,
                                     abundance_column = primary_columns,
                                     sample_comparison = NULL, fdr = fdr,
                                     min_p_threshold = min_p_threshold,
                                     sample_n = sample_n)
      # min_p_threshold is a parameter that will change the output -
      result <- as.data.frame(result)
  }

  else if (enrichment_method == "enrichment_comparison") {
      stopifnot(!is.null(secondary_columns), !is.null(primary_columns))
      result <- enrichment_in_abundance(geneset = geneset, eset = eset,
                                      assay_name = assay_name,
                                      mapping_column = id_column,
                                      abundance_column = primary_columns,
                                      sample_comparison = secondary_columns,
                                      fdr = fdr,
                                      min_p_threshold = min_p_threshold,
                                      sample_n = sample_n)

      result <- as.data.frame(result)
  }


  else if (enrichment_method == "correlation_enrichment") {
    if (is.null(id_column)) {id_column <- NA}
    temp_result <- correlation_enrichment(geneset = geneset,
                                            eset = eset,
                                            assay_name = assay_name,
                                            mapping_column = id_column)

    result <- as.data.frame(temp_result$enrichment)
    attr(result, "corrmat") <- temp_result$corrmat
  }

  else if (enrichment_method == "correlation_comparison") {
    if (is.null(id_column)) {id_column <- NA}
    temp_result <- correlation_comparison_enrichment(geneset = geneset,
                                                     eset = eset,
                                                     assay_name = assay_name,
                                                     set1 = primary_columns,
                                                     set2 = secondary_columns,
                                               mapping_column = id_column)
    result <- as.data.frame(temp_result)
  }
  
  result[,'pvalue'] <- as.numeric(result[,'pvalue'])
  result[,'ingroup_n'] <- as.numeric(result[,'ingroup_n'])
  result[,'outgroup_n'] <- as.numeric(result[,'outgroup_n'])
  result[,'background_n'] <- as.numeric(result[,'background_n'])
  result[,'oddsratio'] <- as.numeric(result[,'oddsratio'])
  result[,'ingroup_mean'] <- as.numeric(result[,'ingroup_mean'])
  result[,'outgroup_mean'] <- as.numeric(result[,'outgroup_mean'])
  result[,'background_mean'] <- as.numeric(result[,'background_mean'])
  result[,'zscore'] <- as.numeric(result[,'zscore'])
  result[,'BH_pvalue'] <- p.adjust(result[,'pvalue'], method = "BH", n = length(which(!is.na(result$pvalue))))
  result[, 'SignedBH_pvalue'] <-
    result[,'BH_pvalue'] * sign(as.numeric(result[,'ingroup_mean']))

  return(result)
}

test_enrichment_comp <- function(){

  protdata.enrichment.svl <- leapR::leapR(
    geneset = ncipid,
    enrichment_method = "enrichment_comparison",
    eset = pset,
    assay_name = "proteomics",
    primary_columns = shortlist,
    secondary_columns = longlist
  )

  sigs <- subset(protdata.enrichment.svl,BH_pvalue < 0.05)

  expect_equal(nrow(sigs), 50)
}

### using enrichment_wrapper function
protdata.enrichment.correlation <- leapR::leapR(
  geneset = ncipid,
  enrichment_method = "correlation_enrichment",
  assay_name = "proteomics",
  eset = pset
)

sigs <- subset(protdata.enrichment.correlation,BH_pvalue < 0.05)

expect_equal(nrow(sigs), 71)

genelist <- rownames(pset)[which(SummarizedExperiment::assay(pset, "proteomics")[, 1] > 0.5)]

protdata.enrichment.sets.test <- leapR::leapR(
  geneset = ncipid,
  enrichment_method = "enrichment_in_sets",
  eset = pset,
  assay_name = "proteomics",
  targets = genelist
)

nsigs <- subset(protdata.enrichment.sets.test,BH_pvalue < 0.5)


expect_equal(nrow(nsigs), 6)

protdata.enrichment.order <- leapR::leapR(
  geneset = ncipid,
  enrichment_method = "enrichment_in_order",
  eset = pset, # threshold=.5,
  assay_name = "proteomics",
  primary_columns = "TCGA-13-1484"
)


sigs <- subset(protdata.enrichment.order,BH_pvalue < 0.5)

expect_equal(nrow(sigs), 5)

## ----knitr, include = FALSE---------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  cache = FALSE
)

## ----libraries, message=FALSE, warning = FALSE--------------------------------
# load the core libraries
library(leapR)
library(gplots)
library(rmarkdown)
# plotting helpers used in this vignette
library(ggplot2)
library(dplyr)
library(tibble)
library(stringr)

## ----load data----------------------------------------------------------------
url <- "https://api.figshare.com/v2/file/download/56536217"
pdata <- download.file(url, method = "libcurl", destfile = "protData.rda")
#  as.matrix()
load("protData.rda")

p <- file.remove("protData.rda")

data(shortlist)
data(longlist)

## columns that we want to use for results

cols_to_display <- c("ingroup_n", "outgroup_n", "background_n", 
                     "pvalue", "BH_pvalue")

## ----compare------------------------------------------------------------------

i = 8
data("ncipid")

cor.res <- do.call(rbind,lapply(1:length(shortlist), function (i) {
  protdata.enrichment.ks <- leapR::leapR(
    geneset = ncipid, "enrichment_in_order",
    eset = pset,
    minsize = 5,
    assay_name = "proteomics",
    primary_columns = shortlist[i]
  )
  
  colnames(protdata.enrichment.ks) <- paste('ks',colnames(protdata.enrichment.ks),sep='.')
  
  
  protdata.enrichment.cs <- leapR::leapR(
    geneset = ncipid, "enrichment_in_order",
    method = 'chisq',
    eset = pset,  minsize = 5,
    assay_name = "proteomics",
    primary_columns = shortlist[i]
  )
  colnames(protdata.enrichment.cs) <- paste('chisq',colnames(protdata.enrichment.cs),sep='.')
  
  protdata.enrichment.zt <- leapR::leapR(
    geneset = ncipid, "enrichment_in_order",
    eset = pset,  minsize = 5,
    method = 'ztest',
    assay_name = "proteomics",
    primary_columns = shortlist[i]
  )
  
  colnames(protdata.enrichment.zt) <- paste('ztest',colnames(protdata.enrichment.zt),sep='.')
  
  paths <- rownames(protdata.enrichment.ks)
  allvals <- cbind(protdata.enrichment.cs[paths,], 
                   protdata.enrichment.ks[paths,], 
                   protdata.enrichment.zt[paths,])

  kz <- cor(allvals$ks.BH_pvalue, allvals$ztest.BH_pvalue, use = 'p')
  
  kc <- cor(allvals$ks.BH_pvalue, allvals$chisq.BH_pvalue, use = 'p')
  
  cz <- cor(allvals$chisq.BH_pvalue, allvals$ztest.BH_pvalue, use = 'p')
  
    kz <- cor(allvals$ks.pvalue, allvals$ztest.pvalue, use = 'p')
  
  kc <- cor(allvals$ks.pvalue, allvals$chisq.pvalue, use = 'p')
  
  cz <- cor(allvals$chisq.pvalue, allvals$ztest.pvalue, use = 'p')
  
  return(c(kz = kc, kc=kc, cz = cz))
}))


## ----compare pvals------------------------------------------------------------
library(ggplot2)

cor.res |> as.data.frame() |>
  tidyr::pivot_longer(c(1:3),names_to='test_comparison',values_to='p cor') |>
  ggplot(aes(x=test_comparison, y= `p cor`)) + geom_jitter()

#' enrichment_by_fishers
#'
#' # helper function for enrichment functions
#' @noRd

enrichment_by_fishers <- function(group, background, annotation) {
  # calculate the fishers exact on a group of things versus a background
  #     for those things with a particular annotation (on another list)

  stopifnot(length(group) > 0,
            length(background) > 0,
            length(annotation) > 0)

  non_group <- background[!background %in% group]

  group_annot <- sum(group %in% annotation)
  group_annot_names <- paste(intersect(group, annotation), collapse = ", ")
  non_group_annot <- sum(non_group %in% annotation)

  group_nonannot <- sum(!group %in% annotation)
  non_group_nonannot <- sum(!non_group %in% annotation)

  test <- matrix(c(group_annot, non_group_annot,
                   group_nonannot, non_group_nonannot),
    nrow = 2,
    dimnames = list(c("Group", "NonGroup"), c("Annotated", "NonAnnotated"))
  )

  per <- c(test[1, 1] / (test[1, 1] + test[1, 2]),
           test[2, 1] / (test[2, 1] + test[2, 2]))

  ft <- fisher.test(test)
  test <- cbind(test, per)

  fold <- per[1] / per[2]

  return(list(fisher = ft, mat = test, foldx = fold,
              in_path_names = group_annot_names))
}

#' cluster_enrichment
#'
#' Cluster enrichment Run enrichment (Fisher's exact) on clusters (lists of
#' identifier groups)
#' @param eset is an SummarizedExperiment containing data that is clustered
#' @param assay_name is the name of the assay
#' @param geneset is a GeneSet object for pathway annotation
#' @param clusters is a list of clusters (gene lists) to calculate enrichment
#'  on, generally the result of the `cutree` function
#' @param sigfilter minimum significance threshold default is .05
#'
#' @details This function will calculate enrichment (Fisher's exact test for
#'  membership overlap) on
#' @details a series of lists of genes, such as from a set of clusters. The
#' results are returned as
#' @details a list of results matrices in the order of the input clusters.
#' @importFrom utils read.table
#' @return data frame with enrichment results
#' @export
#' @examples
#'         library(leapR)
#'
#'         # read in the example transcriptomic data
#'         url <- "https://api.figshare.com/v2/file/download/56536214"
#'         tdata <- download.file(url,method='libcurl',destfile='transData.rda')
#'         load('transData.rda')
#'         p <- file.remove("transData.rda")
#'
#'         # read in the pathways
#'         data("ncipid")
#'
#'         # for the example we will limit the number of transcripts considered
#'         #- arbitrarily in this case
#'         transdata <- SummarizedExperiment::assay(tset,'transcriptomics')
#'         transdata[which(is.na(transdata),arr.ind=TRUE)]<-0.0
#'         # perform heirarchical clustering on the  data
#'         transdata.hc <- hclust(dist(transdata), method="ward.D2")
#'
#'         transdata.hc.clusters <- cutree(transdata.hc, k=5)
#'         clust.list <- lapply(seq_len(5), function(x) {
#'            return(names(which(transdata.hc.clusters==x)))})
#'         #calculates enrichment for each of the clusters individually a
#'         #and returns a list of enrichment results
#'         transdata.hc.enrichment <- leapR::cluster_enrichment(eset=tset,
#'                 assay_name='transcriptomics',
#'                 geneset=ncipid,
#'                 clusters=clust.list)
#'
#'
#'

cluster_enrichment <- function(eset, assay_name, geneset,
                               clusters, sigfilter=0.05) {

  stopifnot(is(geneset,'geneset_data'),
            is(eset,'SummarizedExperiment'),
            length(clusters) > 0)

  x <- length(clusters)

  this <- vapply(seq_len(x), function(i) list(leapR(eset = eset,
                                                      assay_name = assay_name,
                                                      geneset = geneset,
                                                      enrichment_method =
                                                        'enrichment_in_sets',
                                                      targets = clusters[[i]])),
                 data.frame(1))

  # if the sigfilter is set we'll only return those functions that
  # have a p-value  lower than the threshold
  if (is.na(sigfilter)) return(this)

  outlist <- vapply(this, function(these){
    sigs <- which(these$BH_pvalue < sigfilter)
    these <- these[sigs,]
    return(list(these))
    }, list(list))

  return(outlist)
}

#' read_abundance_data
#'
#' This function reads in abundance data
#'
#' @param filename the directory path to a file containing the abundance data
#' @param data_type a character string, either 'protdata' or 'phosphoprotdata'
#'  which describes the type of abundance data
#' @param infocol_name a character string describing the name of the column
#' extra identifier info in abundance data of type 'phosphoprotdata'
#' @noRd
#' @return read in abundance data
#' do we need this function at all?
#'
read_abundance_data <- function(filename, data_type, infocol_name = NULL) {
  # check that data_type is one of the appropriate types
  if (!is.element(data_type, c("protdata", "phospho_protdata")))
    stop("data_type must be one of 'protdata', 'phospho_protdata'")
  if (data_type == "phospho_protdata" & is.null(infocol_name))
    stop("'infocol_name must be provided with 'phospho_protdata' objects")

  df <- read.table(filename, sep = "\t", row.names = 1,
                   header = 1, stringsAsFactors = FALSE)

  # assign "data_type" attribute to df data object
  if (data_type == "phospho_protdata" & !is.null(infocol_name)) {
    if (infocol_name %in% colnames(df)) {
      attr(df, "infocol_name") <- infocol_name
    } else {
      stop("infocol_name is not one of the column names")
    }

    attr(df, "data_type") <- data_type
  }

  class(df) <- c("abundance_data", "data.frame")

  return(df)
}

## ----knitr, include = FALSE---------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  cache = FALSE
)

## ----libraries, message=FALSE, warning = FALSE--------------------------------
# load the core libraries
library(leapR)
library(gplots)
library(rmarkdown)
# plotting helpers used in this vignette
library(ggplot2)
library(dplyr)
library(tibble)
library(stringr)

## ----omicsdata, message=FALSE, warning=FALSE----------------------------------
url <- "https://api.figshare.com/v2/file/download/56536217"
pdata <- download.file(url, method = "libcurl", destfile = "protData.rda")
#  as.matrix()
load("protData.rda")

p <- file.remove("protData.rda")

url <- "https://api.figshare.com/v2/file/download/56536214"
tdata <- download.file(url, method = "libcurl", destfile = "transData.rda")
load("transData.rda")
p <- file.remove("transData.rda")

url <- "https://api.figshare.com/v2/file/download/56536211"
phdata <- download.file(url, method = "libcurl", destfile = "phosData.rda")
load("phosData.rda")
p <- file.remove("phosData.rda")

## ----load lists---------------------------------------------------------------

data(shortlist)
data(longlist)
data(ncipid)
data(kinasesubstrates)
## columns that we want to use for results

cols_to_display <- c("ingroup_n", "outgroup_n", "background_n", 
                     "pvalue", "BH_pvalue")


## ----figure_2, echo=TRUE, warning=FALSE, message=FALSE, error=FALSE-----------
# load the single omic and multi-omic pathway databases
data("krbpaths")
data("mo_krbpaths")

# comparison enrichment in transcriptional data
transdata.comp.enrichment.svl <- leapR::leapR(
  geneset = krbpaths,
  enrichment_method = "enrichment_comparison",
  eset = tset,
  assay_name = "transcriptomics",
  primary_columns = shortlist,
  secondary_columns = longlist
)

# comparison enrichment in proteomics data
# this is the same code used above, just repeated here for clarity
protdata.comp.enrichment.svl <- leapR::leapR(
  geneset = krbpaths,
  enrichment_method = "enrichment_comparison",
  eset = pset,
  assay_name = "proteomics",
  primary_columns = shortlist,
  secondary_columns = longlist
)

# comparison enrichment in phosphoproteomics data
phosphodata.comp.enrichment.svl <- leapR::leapR(
  geneset = krbpaths,
  enrichment_method = "enrichment_comparison",
  eset = phset,
  assay_name = "phosphoproteomics",
  primary_columns = shortlist,
  secondary_columns = longlist, id_column = "hgnc_id"
)


# set enrichment in transcriptomics data
# perform the comparison t-test
tset <- leapR::calcTTest(tset, assay_name = "transcriptomics", 
                         shortlist, longlist)


## now we need to run enrichment in sets with target list, not eset
transdata.set.enrichment.svl <- leapR::leapR(
  geneset = krbpaths,
  eset = tset,
  assay_name = "transcriptomics",
  enrichment_method = "enrichment_in_sets",
  primary_columns = "pvalue",
  greaterthan = FALSE, threshold = 0.05
)


pset <- leapR::calcTTest(pset, assay_name = "proteomics",
                         shortlist, longlist)

protdata.set.enrichment.svl <- leapR::leapR(
  geneset = krbpaths,
  eset = pset,
  assay_name = "proteomics",
  enrichment_method = "enrichment_in_sets",
  primary_columns = "pvalue",
  greaterthan = FALSE, threshold = 0.05
)


phset <- leapR::calcTTest(phset, assay_name = "phosphoproteomics", 
                          shortlist, longlist)

phosphodata.set.enrichment.svl <- leapR::leapR(
  geneset = krbpaths,
  enrichment_method = "enrichment_in_sets",
  id_column = "hgnc_id",
  assay_name = "phosphoproteomics",
  eset = phset, primary_columns = "pvalue",
  greaterthan = FALSE, threshold = 0.05
)

# order enrichment in transcriptomics data
transdata.order.enrichment.svl <- leapR::leapR(
  geneset = krbpaths,
  enrichment_method = "enrichment_in_order",
  eset = tset,
  assay_name = "transcriptomics",
  primary_columns = "difference"
)

# order enrichment in proteomics data
protdata.order.enrichment.svl <- leapR::leapR(
  geneset = krbpaths,
  enrichment_method = "enrichment_in_order",
  eset = pset,
  assay_name = "proteomics",
  primary_columns = "difference"
)

# order enrichment in phosphoproteomics data


phosphodata.order.enrichment.svl <- leapR::leapR(
  geneset = krbpaths,
  enrichment_method = "enrichment_in_order",
  id_column = "hgnc_id",
  method = 'ztest', 
  eset = phset,
  assay_name = "phosphoproteomics",
  primary_columns = "difference"
)

# correlation difference in transcriptomics data
transdata.corr.enrichment.svl <- leapR::leapR(
  geneset = krbpaths,
  enrichment_method = "correlation_comparison",
  eset = tset,
  assay_name = "transcriptomics",
  primary_columns = shortlist,
  secondary_columns = longlist
)
# correlation difference in proteomics data
protdata.corr.enrichment.svl <- leapR::leapR(
  geneset = krbpaths,
  enrichment_method = "correlation_comparison",
  eset = pset,
  assay_name = "proteomics",
  primary_columns = shortlist,
  secondary_columns = longlist
)
# correlation difference in phosphoproteomics data
phosphodata.corr.enrichment.svl <- leapR::leapR(
  geneset = krbpaths,
  enrichment_method = "correlation_comparison",
  eset = phset,
  assay_name = "phosphoproteomics",
  primary_columns = shortlist,
  secondary_columns = longlist, id_column = "hgnc_id"
)

# combine the omics data into one with prefix tags
comboset <- leapR::combine_omics(list(pset, phset, tset), 
                                 c(NA, "hgnc_id", NA))

# comparison enrichment for combodata
# when we use expression set, we do not need to use the mo_krbpaths 
#since the  id mapping column is used
combodata.enrichment.svl <- leapR::leapR(
  geneset = krbpaths, # mo_krbpaths,
  enrichment_method = "enrichment_comparison",
  eset = comboset,
  assay_name = "combined",
  primary_columns = shortlist,
  secondary_columns = longlist, id_column = "id"
)


# set enrichment in combo data
# perform the comparison t test
comboset <- leapR::calcTTest(comboset,
                             assay_name = "combined", 
                             shortlist, longlist)

combodata.set.enrichment.svl <- leapR::leapR(
  geneset = krbpaths,
  enrichment_method = "enrichment_in_sets",
  eset = comboset, primary_columns = "pvalue",
  assay_name = "combined",
  id_column = "id",
  greaterthan = FALSE, threshold = 0.05
)

# order enrichment in combo data
combodata.order.enrichment.svl <- leapR::leapR(
  geneset = krbpaths,
  enrichment_method = "enrichment_in_order",
  assay_name = "combined",
  eset = comboset, primary_columns = "difference",
  id_column = "id"
)

# correlation difference in combo data
combodata.corr.enrichment.svl <- leapR::leapR(
  geneset = krbpaths,
  enrichment_method = "correlation_comparison",
  eset = comboset,
  assay_name = "combined",
  primary_columns = shortlist,
  id_column = "id",
  secondary_columns = longlist
)


# now take all these results and combine them into one figure
all_results <- list(
  transdata.comp.enrichment.svl,
  protdata.comp.enrichment.svl,
  phosphodata.comp.enrichment.svl,
  combodata.enrichment.svl,
  transdata.set.enrichment.svl,
  protdata.set.enrichment.svl,
  phosphodata.set.enrichment.svl,
  combodata.set.enrichment.svl,
  transdata.order.enrichment.svl,
  protdata.order.enrichment.svl,
  phosphodata.order.enrichment.svl,
  combodata.order.enrichment.svl,
  transdata.corr.enrichment.svl,
  protdata.corr.enrichment.svl,
  phosphodata.corr.enrichment.svl,
  combodata.corr.enrichment.svl
)

pathways_of_interest <- c(
  "KEGG_APOPTOSIS",
  "KEGG_CELL_CYCLE",
  "KEGG_ERBB_SIGNALING_PATHWAY",
  "KEGG_FOCAL_ADHESION",
  "KEGG_INSULIN_SIGNALING_PATHWAY",
  "KEGG_MAPK_SIGNALING_PATHWAY",
  "KEGG_MISMATCH_REPAIR",
  "KEGG_MTOR_SIGNALING_PATHWAY",
  "KEGG_OXIDATIVE_PHOSPHORYLATION",
  "KEGG_P53_SIGNALING_PATHWAY",
  "KEGG_PATHWAYS_IN_CANCER",
  "KEGG_PROTEASOME",
  "KEGG_RIBOSOME",
  "KEGG_VEGF_SIGNALING_PATHWAY",
  "KEGG_WNT_SIGNALING_PATHWAY"
)


results.frame <- data.frame(
  pathway = pathways_of_interest,
  td.comp = all_results[[1]][pathways_of_interest, "BH_pvalue"] < 0.05,
  pd.comp = all_results[[2]][pathways_of_interest, "BH_pvalue"] < 0.05,
  fd.comp = all_results[[3]][pathways_of_interest, "BH_pvalue"] < 0.05,
  cd.comp = all_results[[4]][pathways_of_interest, "BH_pvalue"] < 0.05,
  td.set = all_results[[5]][pathways_of_interest, "BH_pvalue"] < 0.05,
  pd.set = all_results[[6]][pathways_of_interest, "BH_pvalue"] < 0.05,
  fd.set = all_results[[7]][pathways_of_interest, "BH_pvalue"] < 0.05,
  cd.set = all_results[[8]][pathways_of_interest, "BH_pvalue"] < 0.05,
  td.order = all_results[[9]][pathways_of_interest, "BH_pvalue"] < 0.05,
  pd.order = all_results[[10]][pathways_of_interest, "BH_pvalue"] < 0.05,
  fd.order = all_results[[11]][pathways_of_interest, "BH_pvalue"] < 0.05,
  cd.order = all_results[[12]][pathways_of_interest, "BH_pvalue"] < 0.05,
  td.corr = all_results[[13]][pathways_of_interest, "BH_pvalue"] < 0.05,
  pd.corr = all_results[[14]][pathways_of_interest, "BH_pvalue"] < 0.05,
  fd.corr = all_results[[15]][pathways_of_interest, "BH_pvalue"] < 0.05,
  cd.corr = all_results[[16]][pathways_of_interest, "BH_pvalue"] < 0.05
)

results.frame.or <- data.frame(
  pathway = pathways_of_interest,
  td.comp = all_results[[1]][pathways_of_interest, "oddsratio"],
  pd.comp = all_results[[2]][pathways_of_interest, "oddsratio"],
  fd.comp = all_results[[3]][pathways_of_interest, "oddsratio"],
  cd.comp = all_results[[4]][pathways_of_interest, "oddsratio"],
  td.set = log(all_results[[5]][pathways_of_interest, "oddsratio"], 2),
  pd.set = log(all_results[[6]][pathways_of_interest, "oddsratio"], 2),
  fd.set = log(all_results[[7]][pathways_of_interest, "oddsratio"], 2),
  cd.set = log(all_results[[8]][pathways_of_interest, "oddsratio"], 2),
  td.order = all_results[[9]][pathways_of_interest, "oddsratio"],
  pd.order = all_results[[10]][pathways_of_interest, "oddsratio"],
  fd.order = all_results[[11]][pathways_of_interest, "oddsratio"],
  cd.order = all_results[[12]][pathways_of_interest, "oddsratio"],
  td.corr = all_results[[13]][pathways_of_interest, "oddsratio"],
  pd.corr = all_results[[14]][pathways_of_interest, "oddsratio"],
  fd.corr = all_results[[15]][pathways_of_interest, "oddsratio"],
  cd.corr = all_results[[16]][pathways_of_interest, "oddsratio"]
)

rownames(results.frame) <- results.frame[, 1]
rownames(results.frame.or) <- results.frame.or[, 1]
results.frame.sig <- results.frame[, 2:17] * results.frame.or[, 2:17]

heatmap.2(as.matrix(results.frame.sig[, c(1:4, 9:16)]), Colv = NA, 
          trace = "none", breaks = c(-1, -.1, -0.0001, 0, 0.1, 1), 
          col = c("blue", "lightblue", "grey", "pink", "red"), 
          dendrogram = "none")

## ----figure_3, warning=FALSE, message=FALSE-----------------------------------
# this comparison of abundance in substrates between case and control
#     is lopsided in the sense that phosphorylation levels were previously
#     reported to be overall higher in the short survivors. Thus the
#     results are not terribly interesting (all kinases are in the same 
# direction)
phosphodata.ksea.comp.svl <- leapR::leapR(
  geneset = kinasesubstrates,
  enrichment_method = "enrichment_comparison",
  eset = phset,
  assay_name = "phosphoproteomics",
  primary_columns = shortlist, secondary_columns = longlist
)


# thus for the example we'll look at correlation between known substrates 
#   in the   case v control conditions
phosphodata.ksea.corr.svl <- leapR::leapR(
  geneset = kinasesubstrates,
  enrichment_method = "correlation_comparison",
  eset = phset,
  assay_name = "phosphoproteomics",
  primary_columns = shortlist,
  secondary_columns = longlist
)

# for the example we are using an UNCORRECTED PVALUE
#     which will allow us to plot more values, but
#     for real applications it's necessary to use the
#     CORRECTED PVALUE

# here are all the kinases *significant (*uncorrected) from the analysis
or <- order(phosphodata.ksea.corr.svl[, "pvalue"])
ksea_result <- phosphodata.ksea.corr.svl[or, ][1:9, ]
ksea_cols <- rep("grey", 9)
ksea_cols[which(ksea_result[, "oddsratio"] > 0)] <- "black"

# plot left panel: correlation significance of top most significant kinases
barplot(ksea_result[, "oddsratio"],
  horiz = TRUE, xlim = c(-1, 0.5),
  names.arg = rownames(ksea_result), las = 1, col = ksea_cols
)

# plot right panel: abundance comparison results of the same kinases
barplot(phosphodata.ksea.comp.svl[rownames(ksea_result), "oddsratio"],
  horiz = TRUE, names.arg = rownames(ksea_result), las = 1, col = "black"
)

---
title: "leapR Paper Examples"
output:
  BiocStyle::html_document:
    toc: true
    toc_depth: 2
vignette: |
  %\VignetteIndexEntry{leapR}   
  %\VignetteEngine{knitr::rmarkdown} 
  %\VignetteEncoding{UTF-8}
---

```{r knitr, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  cache = FALSE
)
```



# Load libraries needed
```{r libraries, message=FALSE, warning = FALSE}
# load the core libraries
library(leapR)
library(gplots)
library(rmarkdown)
# plotting helpers used in this vignette
library(ggplot2)
library(dplyr)
library(tibble)
library(stringr)
```

#  Example data
A sample data set is included that is from the CPTAC study of 169 ovarian
tumors. We include the dataset as a \code{SummarizedExperiment} object, 
containing three assays (transcriptomics, global proteomics, and 
phosphoproteomics) to enable interoperability with other tools, and 
store example file as `rda` on 
[Figshare](https://figshare.com/account/projects/251807/articles/29250845)
as example.

This data can be loaded as follows:
```{r omicsdata, message=FALSE, warning=FALSE}
url <- "https://api.figshare.com/v2/file/download/56536217"
pdata <- download.file(url, method = "libcurl", destfile = "protData.rda")
#  as.matrix()
load("protData.rda")

p <- file.remove("protData.rda")

url <- "https://api.figshare.com/v2/file/download/56536214"
tdata <- download.file(url, method = "libcurl", destfile = "transData.rda")
load("transData.rda")
p <- file.remove("transData.rda")

url <- "https://api.figshare.com/v2/file/download/56536211"
phdata <- download.file(url, method = "libcurl", destfile = "phosData.rda")
load("phosData.rda")
p <- file.remove("phosData.rda")
```

We also have local data we can load

```{r load lists}

data(shortlist)
data(longlist)
data(ncipid)
data(kinasesubstrates)
## columns that we want to use for results

cols_to_display <- c("ingroup_n", "outgroup_n", "background_n", 
                     "pvalue", "BH_pvalue")

```

# Figure 2
We will compare the ability of transcriptomics, proteomics, and 
phosphoproteomics to inform about
differences between short and long surviving patient groups. In addition
to other methods, we also employ a `calcTTest` function that takes 
two sets of samples from the `SummarizedExperiment` object and computes 
the t-test between them. The results are then stored in the `rowData` of the 
same object, so that they can be used for enrichment later on. 

This spans the multiple enrichment methods in leapR and also includes 
multi-omics. 

The resulting heatmap is presented as Figure 2 in the paper.

``` {r figure_2, echo=TRUE, warning=FALSE, message=FALSE, error=FALSE}
# load the single omic and multi-omic pathway databases
data("krbpaths")
data("mo_krbpaths")

# comparison enrichment in transcriptional data
transdata.comp.enrichment.svl <- leapR::leapR(
  geneset = krbpaths,
  enrichment_method = "enrichment_comparison",
  eset = tset,
  assay_name = "transcriptomics",
  primary_columns = shortlist,
  secondary_columns = longlist
)

# comparison enrichment in proteomics data
# this is the same code used above, just repeated here for clarity
protdata.comp.enrichment.svl <- leapR::leapR(
  geneset = krbpaths,
  enrichment_method = "enrichment_comparison",
  eset = pset,
  assay_name = "proteomics",
  primary_columns = shortlist,
  secondary_columns = longlist
)

# comparison enrichment in phosphoproteomics data
phosphodata.comp.enrichment.svl <- leapR::leapR(
  geneset = krbpaths,
  enrichment_method = "enrichment_comparison",
  eset = phset,
  assay_name = "phosphoproteomics",
  primary_columns = shortlist,
  secondary_columns = longlist, id_column = "hgnc_id"
)


# set enrichment in transcriptomics data
# perform the comparison t-test
tset <- leapR::calcTTest(tset, assay_name = "transcriptomics", 
                         shortlist, longlist)


## now we need to run enrichment in sets with target list, not eset
transdata.set.enrichment.svl <- leapR::leapR(
  geneset = krbpaths,
  eset = tset,
  assay_name = "transcriptomics",
  enrichment_method = "enrichment_in_sets",
  primary_columns = "pvalue",
  greaterthan = FALSE, threshold = 0.05
)


pset <- leapR::calcTTest(pset, assay_name = "proteomics",
                         shortlist, longlist)

protdata.set.enrichment.svl <- leapR::leapR(
  geneset = krbpaths,
  eset = pset,
  assay_name = "proteomics",
  enrichment_method = "enrichment_in_sets",
  primary_columns = "pvalue",
  greaterthan = FALSE, threshold = 0.05
)


phset <- leapR::calcTTest(phset, assay_name = "phosphoproteomics", 
                          shortlist, longlist)

phosphodata.set.enrichment.svl <- leapR::leapR(
  geneset = krbpaths,
  enrichment_method = "enrichment_in_sets",
  id_column = "hgnc_id",
  assay_name = "phosphoproteomics",
  eset = phset, primary_columns = "pvalue",
  greaterthan = FALSE, threshold = 0.05
)

# order enrichment in transcriptomics data
transdata.order.enrichment.svl <- leapR::leapR(
  geneset = krbpaths,
  enrichment_method = "enrichment_in_order",
  eset = tset,
  assay_name = "transcriptomics",
  primary_columns = "difference"
)

# order enrichment in proteomics data
protdata.order.enrichment.svl <- leapR::leapR(
  geneset = krbpaths,
  enrichment_method = "enrichment_in_order",
  eset = pset,
  assay_name = "proteomics",
  primary_columns = "difference"
)

# order enrichment in phosphoproteomics data


phosphodata.order.enrichment.svl <- leapR::leapR(
  geneset = krbpaths,
  enrichment_method = "enrichment_in_order",
  id_column = "hgnc_id",
  method = 'ztest', 
  eset = phset,
  assay_name = "phosphoproteomics",
  primary_columns = "difference"
)

# correlation difference in transcriptomics data
transdata.corr.enrichment.svl <- leapR::leapR(
  geneset = krbpaths,
  enrichment_method = "correlation_comparison",
  eset = tset,
  assay_name = "transcriptomics",
  primary_columns = shortlist,
  secondary_columns = longlist
)
# correlation difference in proteomics data
protdata.corr.enrichment.svl <- leapR::leapR(
  geneset = krbpaths,
  enrichment_method = "correlation_comparison",
  eset = pset,
  assay_name = "proteomics",
  primary_columns = shortlist,
  secondary_columns = longlist
)
# correlation difference in phosphoproteomics data
phosphodata.corr.enrichment.svl <- leapR::leapR(
  geneset = krbpaths,
  enrichment_method = "correlation_comparison",
  eset = phset,
  assay_name = "phosphoproteomics",
  primary_columns = shortlist,
  secondary_columns = longlist, id_column = "hgnc_id"
)

# combine the omics data into one with prefix tags
comboset <- leapR::combine_omics(list(pset, phset, tset), 
                                 c(NA, "hgnc_id", NA))

# comparison enrichment for combodata
# when we use expression set, we do not need to use the mo_krbpaths 
#since the  id mapping column is used
combodata.enrichment.svl <- leapR::leapR(
  geneset = krbpaths, # mo_krbpaths,
  enrichment_method = "enrichment_comparison",
  eset = comboset,
  assay_name = "combined",
  primary_columns = shortlist,
  secondary_columns = longlist, id_column = "id"
)


# set enrichment in combo data
# perform the comparison t test
comboset <- leapR::calcTTest(comboset,
                             assay_name = "combined", 
                             shortlist, longlist)

combodata.set.enrichment.svl <- leapR::leapR(
  geneset = krbpaths,
  enrichment_method = "enrichment_in_sets",
  eset = comboset, primary_columns = "pvalue",
  assay_name = "combined",
  id_column = "id",
  greaterthan = FALSE, threshold = 0.05
)

# order enrichment in combo data
combodata.order.enrichment.svl <- leapR::leapR(
  geneset = krbpaths,
  enrichment_method = "enrichment_in_order",
  assay_name = "combined",
  eset = comboset, primary_columns = "difference",
  id_column = "id"
)

# correlation difference in combo data
combodata.corr.enrichment.svl <- leapR::leapR(
  geneset = krbpaths,
  enrichment_method = "correlation_comparison",
  eset = comboset,
  assay_name = "combined",
  primary_columns = shortlist,
  id_column = "id",
  secondary_columns = longlist
)


# now take all these results and combine them into one figure
all_results <- list(
  transdata.comp.enrichment.svl,
  protdata.comp.enrichment.svl,
  phosphodata.comp.enrichment.svl,
  combodata.enrichment.svl,
  transdata.set.enrichment.svl,
  protdata.set.enrichment.svl,
  phosphodata.set.enrichment.svl,
  combodata.set.enrichment.svl,
  transdata.order.enrichment.svl,
  protdata.order.enrichment.svl,
  phosphodata.order.enrichment.svl,
  combodata.order.enrichment.svl,
  transdata.corr.enrichment.svl,
  protdata.corr.enrichment.svl,
  phosphodata.corr.enrichment.svl,
  combodata.corr.enrichment.svl
)

pathways_of_interest <- c(
  "KEGG_APOPTOSIS",
  "KEGG_CELL_CYCLE",
  "KEGG_ERBB_SIGNALING_PATHWAY",
  "KEGG_FOCAL_ADHESION",
  "KEGG_INSULIN_SIGNALING_PATHWAY",
  "KEGG_MAPK_SIGNALING_PATHWAY",
  "KEGG_MISMATCH_REPAIR",
  "KEGG_MTOR_SIGNALING_PATHWAY",
  "KEGG_OXIDATIVE_PHOSPHORYLATION",
  "KEGG_P53_SIGNALING_PATHWAY",
  "KEGG_PATHWAYS_IN_CANCER",
  "KEGG_PROTEASOME",
  "KEGG_RIBOSOME",
  "KEGG_VEGF_SIGNALING_PATHWAY",
  "KEGG_WNT_SIGNALING_PATHWAY"
)


results.frame <- data.frame(
  pathway = pathways_of_interest,
  td.comp = all_results[[1]][pathways_of_interest, "BH_pvalue"] < 0.05,
  pd.comp = all_results[[2]][pathways_of_interest, "BH_pvalue"] < 0.05,
  fd.comp = all_results[[3]][pathways_of_interest, "BH_pvalue"] < 0.05,
  cd.comp = all_results[[4]][pathways_of_interest, "BH_pvalue"] < 0.05,
  td.set = all_results[[5]][pathways_of_interest, "BH_pvalue"] < 0.05,
  pd.set = all_results[[6]][pathways_of_interest, "BH_pvalue"] < 0.05,
  fd.set = all_results[[7]][pathways_of_interest, "BH_pvalue"] < 0.05,
  cd.set = all_results[[8]][pathways_of_interest, "BH_pvalue"] < 0.05,
  td.order = all_results[[9]][pathways_of_interest, "BH_pvalue"] < 0.05,
  pd.order = all_results[[10]][pathways_of_interest, "BH_pvalue"] < 0.05,
  fd.order = all_results[[11]][pathways_of_interest, "BH_pvalue"] < 0.05,
  cd.order = all_results[[12]][pathways_of_interest, "BH_pvalue"] < 0.05,
  td.corr = all_results[[13]][pathways_of_interest, "BH_pvalue"] < 0.05,
  pd.corr = all_results[[14]][pathways_of_interest, "BH_pvalue"] < 0.05,
  fd.corr = all_results[[15]][pathways_of_interest, "BH_pvalue"] < 0.05,
  cd.corr = all_results[[16]][pathways_of_interest, "BH_pvalue"] < 0.05
)

results.frame.or <- data.frame(
  pathway = pathways_of_interest,
  td.comp = all_results[[1]][pathways_of_interest, "oddsratio"],
  pd.comp = all_results[[2]][pathways_of_interest, "oddsratio"],
  fd.comp = all_results[[3]][pathways_of_interest, "oddsratio"],
  cd.comp = all_results[[4]][pathways_of_interest, "oddsratio"],
  td.set = log(all_results[[5]][pathways_of_interest, "oddsratio"], 2),
  pd.set = log(all_results[[6]][pathways_of_interest, "oddsratio"], 2),
  fd.set = log(all_results[[7]][pathways_of_interest, "oddsratio"], 2),
  cd.set = log(all_results[[8]][pathways_of_interest, "oddsratio"], 2),
  td.order = all_results[[9]][pathways_of_interest, "oddsratio"],
  pd.order = all_results[[10]][pathways_of_interest, "oddsratio"],
  fd.order = all_results[[11]][pathways_of_interest, "oddsratio"],
  cd.order = all_results[[12]][pathways_of_interest, "oddsratio"],
  td.corr = all_results[[13]][pathways_of_interest, "oddsratio"],
  pd.corr = all_results[[14]][pathways_of_interest, "oddsratio"],
  fd.corr = all_results[[15]][pathways_of_interest, "oddsratio"],
  cd.corr = all_results[[16]][pathways_of_interest, "oddsratio"]
)

rownames(results.frame) <- results.frame[, 1]
rownames(results.frame.or) <- results.frame.or[, 1]
results.frame.sig <- results.frame[, 2:17] * results.frame.or[, 2:17]

heatmap.2(as.matrix(results.frame.sig[, c(1:4, 9:16)]), Colv = NA, 
          trace = "none", breaks = c(-1, -.1, -0.0001, 0, 0.1, 1), 
          col = c("blue", "lightblue", "grey", "pink", "red"), 
          dendrogram = "none")
```


Figure 3. An application of the KSEA-like approach in leapR as applied to our
          example data. In this example we are looking for known substrate sets
          of kinases (from Phosphosite Plus) that are enriched in the short vs
          long comparison of phosphopeptides.
``` {r figure_3, warning=FALSE, message=FALSE}
# this comparison of abundance in substrates between case and control
#     is lopsided in the sense that phosphorylation levels were previously
#     reported to be overall higher in the short survivors. Thus the
#     results are not terribly interesting (all kinases are in the same 
# direction)
phosphodata.ksea.comp.svl <- leapR::leapR(
  geneset = kinasesubstrates,
  enrichment_method = "enrichment_comparison",
  eset = phset,
  assay_name = "phosphoproteomics",
  primary_columns = shortlist, secondary_columns = longlist
)


# thus for the example we'll look at correlation between known substrates 
#   in the   case v control conditions
phosphodata.ksea.corr.svl <- leapR::leapR(
  geneset = kinasesubstrates,
  enrichment_method = "correlation_comparison",
  eset = phset,
  assay_name = "phosphoproteomics",
  primary_columns = shortlist,
  secondary_columns = longlist
)

# for the example we are using an UNCORRECTED PVALUE
#     which will allow us to plot more values, but
#     for real applications it's necessary to use the
#     CORRECTED PVALUE

# here are all the kinases *significant (*uncorrected) from the analysis
or <- order(phosphodata.ksea.corr.svl[, "pvalue"])
ksea_result <- phosphodata.ksea.corr.svl[or, ][1:9, ]
ksea_cols <- rep("grey", 9)
ksea_cols[which(ksea_result[, "oddsratio"] > 0)] <- "black"

# plot left panel: correlation significance of top most significant kinases
barplot(ksea_result[, "oddsratio"],
  horiz = TRUE, xlim = c(-1, 0.5),
  names.arg = rownames(ksea_result), las = 1, col = ksea_cols
)

# plot right panel: abundance comparison results of the same kinases
barplot(phosphodata.ksea.comp.svl[rownames(ksea_result), "oddsratio"],
  horiz = TRUE, names.arg = rownames(ksea_result), las = 1, col = "black"
)
```

---
title: "leapR"
output:
  BiocStyle::html_document:
    toc: true
    toc_depth: 2
vignette: |
  %\VignetteIndexEntry{leapR}   
  %\VignetteEngine{knitr::rmarkdown} 
  %\VignetteEncoding{UTF-8}
---

```{r knitr, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  cache = FALSE
)
```

# Installation

This is intended to be a short introduction to the `leapR` package. First we
need to load the required libraries:

```{r setup, eval = FALSE}
# install from bioconductor
if (!require(BiocManager)) {
  install.packages('BiocManager')
  BiocManager::install('leapR')
}

```


# Load libraries needed
```{r libraries, message=FALSE, warning = FALSE}
# load the core libraries
library(leapR)
library(gplots)
library(rmarkdown)
# plotting helpers used in this vignette
library(ggplot2)
library(dplyr)
library(tibble)
library(stringr)
```

# Introduction
## Definitions 
*Dataset* - an expression dataset, contained in the Bioconductor 
\code{SummarizedExperiment} object, that at the bare minimum has a matrix of 
components (rows) measured in the same system under multiple different 
conditions (columns)

*Component* - the things being measured, genes, proteins, methylation site,
phosphosite, etc. For functional (currently) the component must be associated 
with a gene name. That is, there's not currently a way to calculate pathway 
enrichment using lipids.

*Pathway* - a set of components that works together to accomplish something or
are related to each other in some other way. This includes classic signaling 
and metabolic pathways, but also molecular function and localization categories
and other groups of related components, like genome location, conservation, etc.

*Condition* - a sample where the treatment, environmental conditions, patient, 
time point or some combination of those is varied. 

The overall idea for functional enrichment is to determine which pathways
are statistically over-represented in one group versus another, display 
statistically differential abundance from one group to another, or are 
statistically differentially distributed in a ranked 
list based on the abundance of one sample. Each of these purposes has a 
different underlying statistical test (or family of tests) and the results of 
each can be interpreted in somewhat different ways. The purpose of this 
vignette  is to give the user a very brief introduction on how to use the
package, not to discuss the underlying statistical choices that need to be 
made when analyzing such data.

There are a number of caveats (probably non-exhaustive) with doing this kind 
of analysis.

## Important points for consideration

### Data normalization
One important point is to use data that's been normalized in a particular 
way to do these analyses. Data here has been normalized as a Z score *by row* 
(gene/protein/etc.). So, for each row, calculate the mean and standard 
deviation across all the conditions (columns) and then express as a Z score. 

Here's why. All high-throughput technologies (microarray, RNAseq, MS-assisted 
proteomics, metabolomics, lipidomics, etc.) suffer from the same limitation.
The detectability of each molecule being detected (protein, RNA, etc.) is 
different and, in general, it's impossible to accurately determine *how 
detectable* each one is. The multi-omic functional enrichment process lumps 
together measurements from different components (proteins, genes, etc.) to 
summarize a pathway. If the component measurements aren't directly comparable 
(they aren't) then this can and will introduce significant systematic errors
and won't produce the results you're looking for. Careful consideration must 
be given that the results of the analysis reflect the question being asked and 
that the normalization method hasn't obscured the desired results.

### Background
The background of comparison for functional enrichment is always important,
but it mainly impacts the Fisher's exact tests in the examples below.
The background answers the question: "My functional group of interest is
statistically enriched relative to what?" For Fisher's exact tests this is
critical. Generally, it is best to compare enrichment against the components
observed in the data (the experiment's universe) rather than the universe of
all possible components. For example, a proteomics dataset from plasma may
contain a limited set of proteins compared with all possible human proteins; 
using the observed proteins as the background usually yields more meaningful 
results. Using all possible proteins will result in substantially different 
findings.

### Multiple hypothesis correction
When testing the statistical significance of differences in a lot of pathways 
it's necessary to correct for multiple hypotheses. This essentially accounts 
for the possibility you might see SOMETHING significant by chance if you just 
test enough things- so it moves p values in a less significant direction. The
more things you test, the greater this move will be. So pathway databases with
lots of pathways are affected more by this correction, making it harder to get
a significant result (which is a good thing actually).

### Pathway databases
Two 'databases' (organized text files) are included for pathways. The example 
is taken from the NCI's Pathway Interaction Database (PID) and covers signaling
pathways in human - but is no longer being actively maintained. 
They can be loaded as follows:

```{r pathdb}
data(ncipid)
```

### Identifiers
The identifiers (gene names, e.g.) for the data input MUST match the 
identifiers used in the pathway database. The two included human databases
use the HGNC-approved gene names. Which means your data has to use the same 
identifiers.

###  Example data
A sample data set is included that is from the CPTAC study of 169 ovarian
tumors. We include the dataset as a \code{SummarizedExperiment} object, 
containing three assays (transcriptomics, global proteomics, and 
phosphoproteomics) to enable interoperability with other tools, and 
store example file as `rda` on 
[Figshare](https://figshare.com/account/projects/251807/articles/29250845)
as example.

This data can be loaded as follows:
```{r omicsdata, message=FALSE, warning=FALSE, echo = FALSE}
url <- "https://api.figshare.com/v2/file/download/56536217"
pdata <- download.file(url, method = "libcurl", destfile = "protData.rda")
#  as.matrix()
load("protData.rda")

p <- file.remove("protData.rda")

url <- "https://api.figshare.com/v2/file/download/56536214"
tdata <- download.file(url, method = "libcurl", destfile = "transData.rda")
load("transData.rda")
p <- file.remove("transData.rda")

url <- "https://api.figshare.com/v2/file/download/56536211"
phdata <- download.file(url, method = "libcurl", destfile = "phosData.rda")
load("phosData.rda")
p <- file.remove("phosData.rda")
```
 
```{r show_pset_example}
# Inspect the `pset` SummarizedExperiment.
str(pset)
dim(SummarizedExperiment::assay(pset, "proteomics"))
head(rownames(pset))
head(colnames(pset))
```
We also include some groups of patients to compare stored as R data objects:
``` {r ptlists}
data(shortlist)
data(longlist)

## columns that we want to use for results

cols_to_display <- c("ingroup_n", "outgroup_n", "background_n", 
                     "pvalue", "BH_pvalue")
```

The data are now loaded and ready to go through some of the examples. 

# Examples

We include five examples of how to use this tool, depending on the analysis at
hand. 
## Comparison of one condition/group versus another condition/group.

There are a number of ways to do this. I generally use a simple approach
which assesses the statistical difference in distributions between the 
abundance values from all the members of a pathway in all the group members
from one group with those from the other group using a t test. 

### Caveat
This is a 'bag of values' approach and it does not pay attention to the
relationships between values in different groups (i.e. that each group
has measurements for the same component). There are likely issues that 
rise because of this and caveats associated with it. However, it works fairly
well.

### Description
In this example we are assessing the enrichment of pathways in
a group of short surviving patients versus in a group of long surviving  
patients. We can also do a single patient-to-patient comparison or compare a 
single patient to a group of patients.

### Interpretation
Better corrected p-values are more enriched. However, you can get good
p-values when the algorithm only considers a limited number of components from 
a pathway. That is, the pathway may have 30 members and the p-value is coming 
from values from just 3 members. You can look at the `ingroup_n` column from 
the result matrix to see this (and screen out if desired).

It is VERY important to also consider the effect size. That is, the difference
between the mean of one group and the mean of the other group. If there are 
large numbers of components in the pathway being compared it is relatively easy
to get a significant p value with small effect size. Though this may be a real
difference it is often not as interesting as a smaller group with worse p value
and greater effect size. You can look at the effect size by comparing the
`ingroup_mean` and `outgroup_mean` columns.

```{r abundance, echo=TRUE, warning=FALSE, message=FALSE}
# in this example we lump a bunch of patients together (the 'short survivors')
# and compare them to another group (the 'long survivors')

### using enrichment_wrapper function
protdata.enrichment.svl <- leapR::leapR(
  geneset = ncipid,
  enrichment_method = "enrichment_comparison",
  eset = pset,
  assay_name = "proteomics",
  primary_columns = shortlist,
  secondary_columns = longlist
)

or <- order(unlist(protdata.enrichment.svl[, "pvalue"]))
rmarkdown::paged_table(protdata.enrichment.svl[or, cols_to_display])
# another application is to compare just one patient against another
# (this would be the  equivalent of comparing one time point to another)

### using enrichment_wrapper function
protdata.enrichment.svl.ovo <- leapR::leapR(
  geneset = ncipid,
  enrichment_method = "enrichment_comparison",
  eset = pset,
  assay_name = "proteomics",
  primary_columns = shortlist[1],
  secondary_columns = longlist[1]
)
or <- order(unlist(protdata.enrichment.svl.ovo[, "pvalue"]))
rmarkdown::paged_table(protdata.enrichment.svl.ovo[or, cols_to_display])
```

When we only compare one sample to another, we get no enriched pathways.

## Fisher's exact test
For this test I use Fisher's exact which is a simple comparison of the overlap 
of two sets (think of it like a statistical Venn diagram with two groups). It's
also  referred to as a hypergeometric test. 

### Caveats
*Caveat 1*. Fisher's exact does not consider abundance values but only lists of
components. Generally this requires some separation of a group of interest
using differential expression, module membership (from a network for example),
or some other method.

*Caveat 2*. The choice of background for comparison can make a big difference 
on outcome. For example, in a proteomics experiment where you're looking at 
enrichment in a group of highly differentially expressed proteins, you could 
choose to use all possible proteins as a background, or you could use just 
those proteins that were observed by proteomics (generally a much more
limited set). The second option is generally the best since the first options
will result in (partly to mostly) functions that are enriched in proteins 
that are seen in proteomics. That is, the most abundant proteins, which is 
generally not the desired outcome.

### Description
In the example below I construct a genelist of interest using a simple 
abundance threshold on the data
then use a background of all the genes in the example dataset (which is a 
limited number). I then do a simple hierarchical clustering on the data, 
extract modules, and step through each module to calculate enrichment for
them, outputting the results into a separate text file.

### Interpretation
As with the t test comparison above it is important to look at the number 
of pathway members included in the comparison (look at the in_path column).
There is no 'effect size' problem with Fisher's exact since it's just a set 
comparison, but it's important to note that significant p values can arise 
from a pathway being *underrepresented* in the genelist, which often times 
is not the desired result. The foldx column gives a ratio of in versus not 
in the genelist, values > 1 being enriched and <1 being depleted.

``` {r fishers, echo=TRUE, warning=FALSE, message=FALSE}
# for this example we will construct a list of genes from the expression data
#     to emulate what you might be inputting
genelist <- rownames(pset)[which(SummarizedExperiment::assay(pset, 
                                                    "proteomics")[, 1] > 0.5)]

protdata.enrichment.sets.test <- leapR::leapR(
  geneset = ncipid,
  enrichment_method = "enrichment_in_sets",
  eset = pset,
  assay_name = "proteomics",
  targets = genelist
)
or <- order(protdata.enrichment.sets.test[, "pvalue"])
rmarkdown::paged_table(protdata.enrichment.sets.test[or, cols_to_display])



# in this example we construct some modules from the hierarchical clustering
#   of the   data
protdata_naf <- SummarizedExperiment::assay(pset, "proteomics")

# hierarchical clustering is not too happy with lots of missing values
#    so we'll do a zero fill on this to get the modules
protdata_naf[which(is.na(protdata_naf))] <- 0

# construct the hierarchical clustering using the 'wardD' method, which
#    seems to give more even sized modules
protdata_hc <- hclust(dist(protdata_naf), method = "ward.D2")

# arbitrarily we'll chop the clusters into 5 modules
modules <- cutree(protdata_hc, k = 5)

## sara: created list
clusters <- lapply(unique(modules), function(x) names(which(modules == x)))

# modules is a named list of values where each value is a module
#         number and the name is the gene name

# To do enrichment for one module (module 1 in this case) do this
protdata.enrichment.sets.module_1 <- leapR::leapR(
  geneset = ncipid,
  enrichment_method = "enrichment_in_sets",
  eset = pset,
  assay_name = "proteomics",
  targets = names(modules[which(modules == 1)])
)

# To do enrichment on all modules and return the list of enrichment results
protdata.enrichment.sets.modules <- do.call(rbind, 
                                            leapR::cluster_enrichment(
                                                eset = pset,
                                                assay_name= 'proteomics',
                                                geneset = ncipid,
                                                clusters = clusters, 
                                                sigfilter = 0.25))
## nothing is enriched
rmarkdown::paged_table(protdata.enrichment.sets.modules[, cols_to_display])
```

#### Visualizing Fisher's exact results
```{r fishers_plot, echo=TRUE, warning=FALSE, message=FALSE}
# Plot the top enriched gene sets from Fisher's exact test
# Stars indicate significance (None seen here)
plot_leapr_bar(
  protdata.enrichment.sets.test,
  title = "Fisher's Exact Test: Top Enriched Pathways",
  top_n = 10,
  star_thresholds = c(0.05, 0.01, 0.001),
  wrap = 40
)
```

## The Kolmogorov–Smirnov test (KS)
Similar to the popular GSEA, KS tests whether a group of components
(the pathway) is distributed in a statistically significant manner in a
ranked list of components. That is, if all the members of the pathway are 
clustered together at the top of the list (highly abundant, e.g.) or at the
bottom of the list (low abundance, e.g.) this will return good p values. 
I should note that GSEA uses a more sophisticated approach than this and 
their application has a lot of bells and whistles.

### Description
In the example below I'm simply calculating enrichment for one of the patients
in the list (arbitrarily selected). The ranking value is relative protein 
abundance in this case, but can be any continuous measure or derived value.
For example, you could calculate the topology of all proteins in a network 
and use the topology measure (degree) as the measure. 

### Interpretation
Similar to the other examples be cautious of pathways with good p values that
consider a small number of pathway numbers (in_path column). The MeanPath 
column gives a measure that shows how far above or below the median the mean 
rank of the pathway is (normalized to -1,1). The Zscore column is a Zscore 
calculated on the basis of the mean percentage rank of the pathway relative 
to the mean of the entire list divided by the standard deviation of the 
pathway rank. The foldx column expresses the mean percentage rank of the 
pathway relative to the entire list - closer to 0 is higher in the list and
closer to 1 is closer to the bottom of the list. Each of these should give 
consistent results, but will be somewhat different.

```{r ks, echo=TRUE, warning = FALSE, message=FALSE}
# This is how you calculate enrichment in a ranked list 
# (for example from topology)
### using enrichment_wrapper function
protdata.enrichment.order <- leapR::leapR(
  geneset = ncipid, "enrichment_in_order",
  eset = pset,
  method = 'ks',
  assay_name = "proteomics",
  primary_columns = shortlist[1]
)


or <- order(protdata.enrichment.order[, "pvalue"])
rmarkdown::paged_table(protdata.enrichment.order[or, cols_to_display])
```

#### Visualizing KS test results
```{r ks_plot, echo=TRUE, warning = FALSE, message=FALSE}
# Plot the ranked enrichment results
plot_leapr_bar(
  protdata.enrichment.order,
  title = "Kolmogorov-Smirnov Test: Ranked Enrichment",
  top_n = 12,
  fill_sig = "#2166AC",
  fill_ns = "#B2DFDB",
  wrap = 38
)
```

### KS alternative: the one-sample Z test

Given that the KS test [has not always been the best for gene set enrichment]() 
we also implement the one-sample z test. 

```{r zt, echo=TRUE, warning = FALSE, message=FALSE}
# This is how you calculate enrichment in a ranked list 
# (for example from topology)
### using enrichment_wrapper function
protdata.enrichment.order <- leapR::leapR(
  geneset = ncipid, "enrichment_in_order",
  eset = pset,
  method = 'ztest',
  assay_name = "proteomics",
  primary_columns = shortlist[1]
)


or <- order(protdata.enrichment.order[, "pvalue"])
rmarkdown::paged_table(protdata.enrichment.order[or, cols_to_display])

plot_leapr_bar(
  protdata.enrichment.order,
  title = "Z Test: Ranked Enrichment",
  top_n = 12,
  fill_sig = "#2166AC",
  fill_ns = "#B2DFDB",
  wrap = 38
)
```

## Enrichment in Correlation
The idea here is to use the correlation of pathway members to each other versus 
to non-pathway members as a way to assess functional enrichment. This idea 
seems sound- pathways that are varying in a correlated way across a bunch of
conditions (say time points or patients) may be more active and more important
than others. However, more testing and validation is needed to show that this 
is the case.

### Interpretation
The `ingroup_mean` gives the mean correlation of the pathway members to each 
other and outgroup_mean gives the correlation of the pathway members to 
non-pathway members. Background_mean gives the mean correlation of all 
non-pathway members. The `pvalue` and `BH_pvalue` are for the pathway members
to each other versus those pathway members to non-pathway components. The 
`pvalue_background` and `BH_pvalue_background` are for the pathway member 
correlation relative to non-pathway member correlation (which is similar but 
slightly different than the other p-values).

```{r correlation, echo=TRUE, warning=FALSE, message=FALSE}
### using enrichment_wrapper function
protdata.enrichment.correlation <- leapR::leapR(
  geneset = ncipid,
  enrichment_method = "correlation_enrichment",
  assay_name = "proteomics",
  eset = pset
)

or <- order(protdata.enrichment.correlation[, "pvalue"])
rmarkdown::paged_table(head(protdata.enrichment.correlation[or, 
                                                      cols_to_display]))

protdata.enrichment.correlation.short <- leapR::leapR(
  geneset = ncipid,
  enrichment_method = "correlation_enrichment",
  assay_name = "proteomics",
  eset = pset[, shortlist]
)
or <- order(protdata.enrichment.correlation.short[, "pvalue"])
rmarkdown::paged_table(head(protdata.enrichment.correlation.short[or, 
                                                        cols_to_display]))

protdata.enrichment.correlation.long <- leapR::leapR(
  geneset = ncipid,
  enrichment_method = "correlation_enrichment",
  assay_name = "proteomics",
  eset = pset[, longlist]
)
or <- order(protdata.enrichment.correlation.long[, "pvalue"])
rmarkdown::paged_table(head(protdata.enrichment.correlation.long[or, 
                                                            cols_to_display]))
```

#### Visualizing correlation enrichment results
```{r corr_plot, echo=TRUE, warning=FALSE, message=FALSE}
# Compare correlation patterns across conditions
plot_leapr_bar(
  protdata.enrichment.correlation.short,
  title = "Correlation Enrichment: Short Survivors",
  top_n = 10,
  fill_sig = "#1B9E77",
  fill_ns = "#D8F0E8",
  wrap = 36
)
```

## Phosphoproteomics data analysis

In this example we will use phosphoproteomics data to assess the enrichment 
in known kinase substrates (a proxy for kinase activity)

```{r phosphoproteomics, echo=TRUE, warning=FALSE, message=FALSE}
data("kinasesubstrates")

# for an individual tumor calculate the Kinase-Substrate 
# Enrichment (similar to KSEA)
#     This uses the site-specific phosphorylation data to determine 
# which kinases
#     might be active by assessing the enrichment of the 
# phosphorylation of their known substrates

phosphodata.ksea.order <- leapR::leapR(
  geneset = kinasesubstrates,
  enrichment_method = "enrichment_in_order",
  assay_name = "phosphoproteomics",
  eset = phset,
  method = 'ztest', 
  primary_columns = "TCGA-13-1484")

or <- order(phosphodata.ksea.order[, "pvalue"])
rmarkdown::paged_table(phosphodata.ksea.order[or, cols_to_display])


# now do the same thing but use a threshold
phosphodata.sets.order <- leapR::leapR(
  geneset = kinasesubstrates,
  enrichment_method = "enrichment_in_sets",
  eset = phset,
  assay_name = "phosphoproteomics",
  threshold = 0.5,
  primary_columns = "TCGA-13-1484"
)
or <- order(phosphodata.sets.order[, "pvalue"])
rmarkdown::paged_table(phosphodata.sets.order[or, cols_to_display])
```

#### Visualizing kinase substrate enrichment
```{r phos_plot, echo=TRUE, warning=FALSE, message=FALSE}
plot <- plot_leapr_bar(
  phosphodata.sets.order,
  title            = "Kinase Substrate Enrichment (Phosphoproteomics)",
  top_n            = 15,
  star_thresholds  = c(0.05, 0.01, 1e-3),
  wrap             = 36,
  fill_sig         = "#0F766E",  # dark teal for significant
  fill_ns          = "#99F6E4",  # light teal for non-significant
  outline          = "grey30",
  axis_text_y_size = 7,
  axis_text_x_size = 8
)

plot

# You can also modify the plot further using standard ggplot2 arguments
plot + ggplot2::labs(
  y = expression(-log[10]("adjusted p-value")),
  caption = "* p<0.05, ** p<0.01, *** p<0.001"
)
```



Lastly we print out the session info!
```{r session}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/calcTTest.R
\name{calcTTest}
\alias{calcTTest}
\title{calcTTest}
\usage{
calcTTest(eset, assay_name, group1, group2)
}
\arguments{
\item{eset}{SummarizedExperiment}

\item{assay_name}{name of assay}

\item{group1}{List of samples comprising group 1}

\item{group2}{List of samples comprising group 2}
}
\value{
An Expression set with two columns added to the featureData
slot: pvalue, and estimate
}
\description{
calculates a t-test for two distributions of data on a per-gene basis
append results to ExpressionSet with two extra columns: `pvalue` and
`difference` for each feature
}
\examples{

        library(leapR)
        url <- "https://api.figshare.com/v2/file/download/56536214"
        tdata <- download.file(url,method='libcurl',destfile='transData.rda')
        load('transData.rda')
        p <- file.remove("transData.rda")

        # read in the pathways
        data("ncipid")

        # read in the patient groups
        data("shortlist")
        data("longlist")
        calcTTest(tset, 'transcriptomics', shortlist, longlist)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/leapR-package.R
\docType{package}
\name{leapR-package}
\alias{leapR-package}
\title{leapR: Layered enrichment analysis of pathways R}
\description{
leapR is a package that identifies pathways that are enriched across diverse 'omics experiments. It leverages any tabular expression data (proteomics, transcriptomics) using the `SummarizedExperiment` object. It works with any pathway in the .gct file format.
}
\author{
\strong{Maintainer}: Sara Gosline \email{sara.gosline@pnnl.gov} (\href{https://orcid.org/0000-0002-6534-4774}{ORCID})

Authors:
\itemize{
  \item Jason McDermott \email{jason.mcdermott@pnnl.gov}
  \item Jeremy Jacobson \email{jeremy.jacobson@pnnl.gov}
}

Other contributors:
\itemize{
  \item Vincent Danna \email{vincent.danna@pnnl.gov} [contributor]
  \item National Institutes of Health [funder]
}

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/drug_barplots.R
\name{plot_leapr_bar}
\alias{plot_leapr_bar}
\title{Plot leapR pathway bars (single panel)}
\usage{
plot_leapr_bar(
  res_df,
  title = NULL,
  top_n = 15,
  star_thresholds = c(0.05, 0.01, 0.001),
  wrap = 42,
  max_stars = 5L,
  fill_sig = "#2C7BB6",
  fill_ns = "#BFD7FF",
  outline = NA,
  axis_text_y_size = 8,
  axis_text_x_size = 9
)
}
\arguments{
\item{res_df}{A leapR df containing BH_pvalue (or pvalue) and a pathway/term label column.}

\item{title}{Plot title.}

\item{top_n}{Number of top pathways/genes to display.}

\item{star_thresholds}{list of numeric significance thresholds for star annotations.}

\item{wrap}{Wrap width for pathway labels (helps formatting).}

\item{max_stars}{Maximum number of stars to draw per bar (default 5).}

\item{fill_sig}{Fill color for significant bars}

\item{fill_ns}{Fill color for non-significant bars.}

\item{outline}{Bar border color.}

\item{axis_text_y_size}{Font size for y-axis (category) labels.}

\item{axis_text_x_size}{Font size for x-axis (numeric) labels.}
}
\value{
A \pkg{ggplot2} object (or \code{NULL} if nothing to plot).
}
\description{
This plotting helper expects leapR generated results to plot.
It will use BH_pvalue if present, otherwise pvalue.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{krbpaths}
\alias{krbpaths}
\title{KEGG, Reactome, BioCarta Pathways}
\format{
A list with 4 items
\describe{
\item{names}{The names of the pathways}
\item{desc}{Short description of the pathways}
\item{sizes}{Number of genes in the signaling pathways}
\item{matrix}{Matrix containing the genes in the pathways}
}
}
\source{
https://www.gsea-msigdb.org/gsea/msigdb_license_terms.jsp
}
\usage{
krbpaths
}
\description{
KEGG, Reactome, BioCarta Pathways
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{kinasesubstrates}
\alias{kinasesubstrates}
\title{Kinase substrate lists}
\format{
A list with 4 items
\describe{
\item{names}{The names of the kinases}
\item{desc}{Short description of the kinase}
\item{sizes}{Length of the substrate list}
\item{matrix}{Substrate list for the kinase}
}
}
\source{
PhosphositePlus
}
\usage{
kinasesubstrates
}
\description{
Kinase substrate lists
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/combine_omics.R
\name{combine_omics}
\alias{combine_omics}
\title{combine_omics
Combine two or more omics matrices into one multi-omics matrix with
'tagged' ids.}
\usage{
combine_omics(omics_list, id_list = rep(NA, length(omics_list)))
}
\arguments{
\item{omics_list}{Is a list of \code{SummarizedExperiment} each with
one assay}

\item{id_list}{List of identifiers to use, in the same order as the
omics_list elements. If an element
is `NA`, then rownames are used.}
}
\value{
\code{SummarizedExperiment} with an additional assay called
 `combined`
}
\description{
combine_omics
Combine two or more omics matrices into one multi-omics matrix with
'tagged' ids.
}
\details{
This combines matrices of different omics types together and
adds prefix tags to the ids.
}
\examples{
        library(leapR)
        url <- 'https://api.figshare.com/v2/file/download/56536217'

        pdata <- download.file(url,method='libcurl',destfile='protData.rda')
        load('protData.rda')
        p <- file.remove("protData.rda")

        url <- "https://api.figshare.com/v2/file/download/56536214"
        tdata <- download.file(url,method='libcurl',destfile='transData.rda')
        load('transData.rda')
        p <- file.remove("transData.rda")

        url <- 'https://api.figshare.com/v2/file/download/56536211'
        phdata<-download.file(url,method='libcurl',destfile = 'phosData.rda')
        #phosphodata<-read.csv("phdata",check.names=FALSE,row.names=1)
        load('phosData.rda')
        p <- file.remove('phosData.rda')# read in the example protein data


        # merge the three datasets by rows and add prefix tags for
        # different omics types
        multi_omics <- combine_omics(list(pset, tset, phset),
                    list(NA,NA,'hgnc_id'))


}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/enrichment_in_abundance.R
\name{enrichment_in_abundance}
\alias{enrichment_in_abundance}
\title{enrichment_in_abundance}
\usage{
enrichment_in_abundance(
  geneset,
  eset,
  assay_name,
  mapping_column = NULL,
  abundance_column = NULL,
  fdr = 0,
  matchset = NULL,
  sample_comparison = NULL,
  min_p_threshold = NULL,
  sample_n = NULL,
  silence_try_errors = TRUE
)
}
\arguments{
\item{geneset}{Gene set to calculate enrichment}

\item{eset}{Molecular abundance data in `SummarizedExperiment` format}

\item{assay_name}{Name of assay to compare}

\item{mapping_column}{Column to use to map identifiers}

\item{abundance_column}{Columns to use to quantify abundance}

\item{fdr}{number of times to sample for FDR value}

\item{matchset}{Name of a set to use for enrichment}

\item{sample_comparison}{list of samples to use as comparison. if missing
background (eset) is used}

\item{min_p_threshold}{Only include p-values lower than this}

\item{sample_n}{size of sample to use}

\item{silence_try_errors}{set to true to silence try errors}
}
\value{
data frame of enrichment result
}
\description{
Enrichment in abundance calculates enrichment in pathways by the difference
in abundance of the pathway members.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{shortlist}
\alias{shortlist}
\title{A list of pathways and genes that comprise these pathways from msigdb}
\format{
a list with 4 items

Short list of patient samples
}
\usage{
shortlist
}
\description{
A list of pathways and genes that comprise these pathways from msigdb
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/enrichment_in_groups.R
\name{enrichment_in_groups}
\alias{enrichment_in_groups}
\title{enrichment_in_groups}
\usage{
enrichment_in_groups(
  geneset,
  targets = c(),
  background = NULL,
  assay_name = NULL,
  method = "fishers",
  minsize = 5,
  mapping_column = NULL,
  log_transformed = FALSE,
  abundance_column = NULL,
  randomize = FALSE,
  silence_try_errors = TRUE
)
}
\arguments{
\item{geneset}{geneset to use for enrichment}

\item{targets}{targets to use for enrichment}

\item{background}{`SummarizedExperiment` describing background to use}

\item{assay_name}{is the name of the assay to use from the background}

\item{method}{method to use for statistical test, options are
'fishers', 'ks', 'ztest', or 'chisq'. Remember that KS test assumes normality, so it would be good
to log your data before calling. NOTE: if you do not call `suppressWarnings` then
the KS test will warn you about ties.}

\item{minsize}{minimum size of set}

\item{mapping_column}{column name of mapping identifiers}

\item{log_transformed}{Set to TRUE if data are log transformed}

\item{abundance_column}{columns mapping abundance, either in the `assay`
matrix or `rowData`}

\item{randomize}{true/false whether to randomize}

\item{silence_try_errors}{true/false to silence errors}
}
\value{
data frame with enrichment results
}
\description{
Calculate the enrichment in pathways using Fisher's exact or
Kolmogorov-Smirnov test, using either the abundance column to identify
feature or the targets list. access through leapr wrapper
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{longlist}
\alias{longlist}
\title{Long list of patient samples}
\format{
An object of class \code{character} of length 37.
}
\usage{
longlist
}
\description{
Long list of patient samples
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{ncipid}
\alias{ncipid}
\title{NCI Gene lists}
\format{
A list with 4 items
\describe{
\item{names}{The names of the signaling pathways}
\item{desc}{Short description of the pathways}
\item{sizes}{Number of genes in the signaling pathways}
\item{matrix}{Matrix containing the genes in the pathways}
}
}
\source{
NCIPID
}
\usage{
ncipid
}
\description{
A list of pathways and the genes that comprise these pathways
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/enrichment_in_relationships.R
\name{enrichment_in_relationships}
\alias{enrichment_in_relationships}
\title{enrichment_in_relationships}
\usage{
enrichment_in_relationships(
  geneset,
  relationships,
  idmap = NA,
  silence_try_errors = TRUE
)
}
\arguments{
\item{geneset}{List of pathways in gmt format}

\item{relationships}{table of relationship information, e.g. correlation}

\item{idmap}{list of identifiers to use for mapping, the names of the items
should agree with names of features in matrix}

\item{silence_try_errors}{boolean to silence errors}
}
\value{
table of enrichment statistics
}
\description{
enrichment_in_relationships function description is a general way to
determine if a pathway
is enriched in relationships (interactions, correlation) between its members
# access through leapr wrapper
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/correlation_comparison_enrichment.R
\name{correlation_comparison_enrichment}
\alias{correlation_comparison_enrichment}
\title{correlation_comparison_enrichment}
\usage{
correlation_comparison_enrichment(
  geneset,
  eset,
  assay_name,
  set1,
  set2,
  mapping_column = NA
)
}
\arguments{
\item{geneset}{pathway to use for enrichment}

\item{eset}{SummarizedExperiment with abundance matrix}

\item{assay_name}{name of assay}

\item{set1}{first set to use}

\item{set2}{second set to use}

\item{mapping_column}{Column to use for id mapping within rowData}
}
\value{
data frame with enrichment results
}
\description{
# internal function to calculate enrichment in differences in correlation
# between two groups
# access through the leapr wrapper
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cluster_enrichment.R
\name{cluster_enrichment}
\alias{cluster_enrichment}
\title{cluster_enrichment}
\usage{
cluster_enrichment(eset, assay_name, geneset, clusters, sigfilter = 0.05)
}
\arguments{
\item{eset}{is an SummarizedExperiment containing data that is clustered}

\item{assay_name}{is the name of the assay}

\item{geneset}{is a GeneSet object for pathway annotation}

\item{clusters}{is a list of clusters (gene lists) to calculate enrichment
on, generally the result of the `cutree` function}

\item{sigfilter}{minimum significance threshold default is .05}
}
\value{
data frame with enrichment results
}
\description{
Cluster enrichment Run enrichment (Fisher's exact) on clusters (lists of
identifier groups)
}
\details{
This function will calculate enrichment (Fisher's exact test for
 membership overlap) on

a series of lists of genes, such as from a set of clusters. The
results are returned as

a list of results matrices in the order of the input clusters.
}
\examples{
        library(leapR)

        # read in the example transcriptomic data
        url <- "https://api.figshare.com/v2/file/download/56536214"
        tdata <- download.file(url,method='libcurl',destfile='transData.rda')
        load('transData.rda')
        p <- file.remove("transData.rda")

        # read in the pathways
        data("ncipid")

        # for the example we will limit the number of transcripts considered
        #- arbitrarily in this case
        transdata <- SummarizedExperiment::assay(tset,'transcriptomics')
        transdata[which(is.na(transdata),arr.ind=TRUE)]<-0.0
        # perform heirarchical clustering on the  data
        transdata.hc <- hclust(dist(transdata), method="ward.D2")

        transdata.hc.clusters <- cutree(transdata.hc, k=5)
        clust.list <- lapply(seq_len(5), function(x) {
           return(names(which(transdata.hc.clusters==x)))})
        #calculates enrichment for each of the clusters individually a
        #and returns a list of enrichment results
        transdata.hc.enrichment <- leapR::cluster_enrichment(eset=tset,
                assay_name='transcriptomics',
                geneset=ncipid,
                clusters=clust.list)



}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/correlation_enrichment.R
\name{correlation_enrichment}
\alias{correlation_enrichment}
\title{correlation_enrichment}
\usage{
correlation_enrichment(geneset, eset, assay_name, mapping_column = NA)
}
\arguments{
\item{geneset}{Geneset list}

\item{eset}{a SummarizedExperiment object}

\item{assay_name}{name of assay}

\item{mapping_column}{Column to use to map identifiers, if not rownames}
}
\value{
list of enrichment statistic table and correlation matrix
}
\description{
# calculate enrichment in correlation between pathway members
# access through leapr wrapper
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/leapR.R
\name{leapR}
\alias{leapR}
\title{leapR}
\usage{
leapR(geneset, enrichment_method, eset, assay_name, ...)
}
\arguments{
\item{geneset}{is a list of four vectors, gene names, gene descriptions, gene
sizes and a matrix of genes. It represents .gmt format pathway files.}

\item{enrichment_method}{is a character string specifying the method of
enrichment to be performed, one of: "enrichment_comparison",
"enrichment_in_order", "enrichment_in_sets", "enrichment_in_pathway",
"correlation_enrichment".}

\item{eset}{is a `SummarizedExperiment` object containing expression data,
with features as rows and \emph{n} sample/conditions as columns.}

\item{assay_name}{is the assay to be analyzed within the `eset`.
Recommended to describe the data type (e.g. transcriptomics, proteomics)
so that it can be integrated in `combine_omics`}

\item{...}{further arguments}
}
\value{
data frame with results
}
\description{
leapR is a wrapper function that consolidates multiple enrichment methods.
}
\details{
Further arguments and enrichment method optional argument information: \cr
\tabular{ll}{
id_column \tab Is a character string, present in the \code{rowData} slot,
that is used to specify a column for identifiers to map to enrichment
libraries.
If missing, the rownames of the SummarizedExperiment assay will be used.
\cr
primary_columns \tab Is a character vector composed of column names from
\code{eset} (either in the `assay` or in the `rowData`),
that specifies a set of primary columns to calculate enrichment on.
The meaning of this varies according to the enrichment method used - see
the descriptions for each method below.
This is an optional argument used with 'enrichment_in_order',
'enrichment_in_sets', and 'enrichment_comparison' methods. \cr
\cr
secondary_columns \tab Is a character vector of column names for comparison,
pulled from the `assay` of the SummarizedExperiment. This is an
optional argument used with 'enrichment_comparison' methods. \cr
\cr
threshold \tab Is a numeric value, an optional argument used with
'enrichment_in sets' method which filters out abundance values or p-values
(depending on what `primary_columns` is used)
either above or below it. \cr
\cr
greaterthan \tab Is a logical value that defaults to TRUE, it's used with
'enrichment_in_sets' method.
When set to TRUE, genes with `primary_columns` value above the
\code{threshold} argument are kept.
When set to FALSE genes with `primary_columns` value below the
\code{threshold} argument are kept.
This is an optional argument used with 'enrichment_in_sets' method. \cr
\cr
minsize \tab Is a numeric value, an optional argument used with
'enrichment_in_sets' and 'enrichment_in_order". \cr
\cr
fdr \tab A numerical value which specifies how many times to randomly
sample genes to calculate an empirical false discovery rate, is an optional
argument used with 'enrichment_comparison' method. \cr
\cr
min_p_threshold \tab Is a numeric value, a lower p-value threshold and is an
optional argument used with 'enrichment_comparison' method. \cr
\cr
sample_n \tab Is a way to subsample the number of components considered for
each calculation randomly. This is an optional argument used with
'enrichment_comparison' method. \cr
\cr
}

\strong{Enrichment Methods:}
\cr
\cr
enrichment_comparison
\cr
Compares the distribution of abundances between two sets of
conditions for each pathway using a t test. For each pathway in
\code{geneset} uses a t test to compare the distribution of abundance
values/numbers in \code{eset} \code{primary_columns} with those in
\code{eset} \code{secondary_columns}. Lower p-values for pathways indicate
that the expression of the pathway is significantly different between the
set of conditions in primary_columns and the set of conditions in
secondary_columns.
Optionally, users can specify \code{fdr} which will calculate an empirical
p-value by randomizing abundances \code{fdr} number of times. If the
\code{min_p_threshold} is specified the method will only return pathways
with an adjusted p-value lower than the specified threshold. If
\code{sample_n} is specified the method will subsample the
pathway members to the specified number of components.
\cr \cr
enrichment_in_order
\cr
Calculates enrichment of pathways based on a ranked list using the
Kolmogorov-Smirnov test. For each pathway in \code{geneset} uses a
Kolmogorov-Smirnov test for rank order to test if the distribution of ranked
abundance values in the \code{eset} \code{primary_columns} is significant
relative to a random distribution. Note that currently
\code{primary_columns} only accepts a single column for this method.
\cr \cr
enrichment_in_sets
\cr
Calculates enrichment in pathway membership in a list (e.g. highly
differential proteins) relative to background using Fisher's exact test. For
each pathway in \code{geneset} uses a Fisher's exact test over- or under-
representation of a list of components specified. If \code{targets} are
specified this must be a vector of identifiers to serve as the target list
for comparison. If \code{eset} and \code{primary_columns} are specified then
\code{threshold} specifies a threshold value for determining the target list
of components to test. Specifying \code{greaterthan} to be False
will result in components with values lower than the specified
\code{threshold}. If \code{eset} is a data frame or matrix, the background
used for calculation will be taken as the rownames of \code{eset}
\cr \cr
enrichment_in_pathway
\cr
Compares the distribution of abundances in a pathway with the background
distribution of abundances using a t test. For each pathway in
\code{geneset} calculates the significance of the difference between the
abundances from pathway members versus abundance of non-pathway members in
the set of conditions specified by \code{primary_columns}. Optionally, users
can specify \code{fdr} which will calculate an empirical p-value by
randomizing abundances \code{fdr} number of times. If the
\code{min_p_threshold} is specified the method will only return pathways
with an adjusted p-value lower than the specified threshold. If
\code{sample_n} is specified the method will subsample the
pathway members to the specified number of components.
\cr \cr
correlation_enrichment
\cr
Calculates the enrichment of a pathway based on correlation between pathway
members across conditions versus correlation between members not in the
pathway. For each pathway in \code{geneset} calculates the pairwise
correlation between all pathway members and non-pathway members
across the specified \code{primary_columns} conditions in \code{eset}. Note
that for large matrices this can take a long time. A p-value is calculated
based on comparing the correlation within the members of a pathway with the
correlation values between members of the pathway and non-members of the
pathway.
\cr
}
\examples{
        library(leapR)

 # read in the example abundance data
 # read in the example transcriptomic data
 tdata <- download.file("https://api.figshare.com/v2/file/download/56536214",
      method='libcurl',destfile='transData.rda')
 load('transData.rda')
 p <- file.remove("transData.rda")

 # read in the pathways
 data("ncipid")

 # read in the patient groups
 data("shortlist")
 data("longlist")

 # use enrichment_comparison to calculate enrichment in one set of
 # conditions (shortlist) and another (longlist)
 short_v_long = leapR(geneset=ncipid, assay_name='transcriptomics',
              enrichment_method='enrichment_comparison',
              eset=tset, primary_columns=shortlist,
               secondary_columns=longlist)

 # use enrichment_in_sets to calculate the most enriched pathways
 # from the highest abundance proteins
 #     from one condition
 onept_sets = leapR(geneset=ncipid, assay_name='transcriptomics',
               enrichment_method='enrichment_in_sets',
               eset=tset, primary_columns="TCGA-13-1484", threshold=1.5)

 # use enrichment_in_order to calculate the most enriched pathways from the
 # same condition
 # Note: that this uses the entire set of abundance values and their order -
 # whereas the previous example uses a hard threshold to get a short list of
 # most abundant proteins and calculates enrichment based on set overlap.
 # The results are likely to be similar - but with some notable differences.
 onept_order = leapR(geneset=ncipid, assay_name='transcriptomics',
               enrichment_method='enrichment_in_order',
               eset=tset, primary_columns="TCGA-13-1484")

 # use enrichment_in_pathway to calculate the most enriched pathways in a
 # set of conditions based on abundance in the pathway members versus
 # abundance in non-pathway members
 short_pathways = leapR(geneset=ncipid, assay_name='transcriptomics',
               enrichment_method='enrichment_in_pathway',
               eset=tset, primary_columns=shortlist)

 # use correlation_enrichment to calculate the most enriched pathways in
 # correlation across the shortlist conditions
 short_correlation_pathways = leapR(geneset=ncipid,
                assay_name='transcriptomics',
                enrichment_method='correlation_enrichment',
                eset=tset, primary_columns=shortlist)


}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/read_gene_sets.R
\name{read_gene_sets}
\alias{read_gene_sets}
\title{read_gene_sets}
\usage{
read_gene_sets(
  gsfile,
  gene.labels = NA,
  gs.size.threshold.min = 5,
  gs.size.threshold.max = 15000
)
}
\arguments{
\item{gsfile}{is a gene set file, for example a .gmt file
(gene matrix transposed file format)}

\item{gene.labels}{defaults to NA}

\item{gs.size.threshold.min}{defaults to 5}

\item{gs.size.threshold.max}{defaults to 15000}
}
\value{
gene set object

geneset list
}
\description{
read_gene_sets is a function to import external pathway
database files in .gmt format
}
\examples{
gfile <- system.file('extdata','h.all.v2024.1.Hs.symbols.gmt',
          package='leapR')
glist <- read_gene_sets(gfile)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get_pathway_information.R
\name{get_pathway_information}
\alias{get_pathway_information}
\title{get_pathway_information}
\usage{
get_pathway_information(geneset, path, remove.tags = FALSE)
}
\arguments{
\item{geneset}{is a GeneSet object for pathway annotation}

\item{path}{is the name of the gene set pathway to be return}

\item{remove.tags}{boolean indicating whether to remove tags}
}
\value{
list of pathway information
}
\description{
get_pathway_information extracts information about a pathway from a
GeneSet object
}
\examples{

     library(leapR)

     # load example gene set
     data("ncipid")

     tnfpathway = get_pathway_information(ncipid, "tnfpathway")


}
